var DBG = DBG || 0;

if (!URL_TABLE_POWIAZANIA) throw "Brak URL_TABLE_POWIAZANIA";
if (!BASE_URLS) throw "Brak BASE_URLS"

var RECORD_MORE_FUNCTIONS_OPENED_NODE = null;
if (!FIELD_LIST_PRACOWNICY) throw "Brak FIELD_LIST_PRACOWNICY"
if (!FIELD_LIST_KONTRAHENCI) throw "Brak FIELD_LIST_KONTRAHENCI"

$(window).on('hashchange', function() {
	initLocalStorage();
	rootChangeForm();
	updateTopCounters();
	hideMoreRecordFunctionsPopover()
});


/* DATA FOR READ REAPORT */

function urlFetchKontrahenciPowiazania() {
	// Documentation: https://github.com/github/fetch
	fetch(URL_FETCH_KONTRAHENCI_POWIAZANIA, {
		credentials: 'same-origin'
	})
	.then(function parseJSON(response) {
	  return response.json()
	})
	.then(function(data) {

		var reaportItemsKontrahenciPowiazani = null;
		data.body.items.forEach (function(row) {
			reaportItemsKontrahenciPowiazani += '<tr><td><input type="checkbox" name="kontrID[]" value="'+row['ID']+'" /></td>'+
				'<td align="right">'+row["ID"]+'</td>';
		});

		$( "#body-reaport-kontrahenci-powiazani-tree" ).html(reaportItemsKontrahenciPowiazani);

	}).catch(function(error) {
		if(DBG) console.log('request failed', error)
	});
}


/* FORM DATA FOR GENERATAE REAPORT */
/**
 * Load data default title reaport in storage
 */
function loadCurrentReaportTitleInInput(idInput) {
  var reaportTitleValue = getItemLocalStorage("Bocian.biAuditForm.smadReaportTitle");

  if ( getItemLocalStorage('Bocian.biAuditForm.smadReaportTitle') === null ) {
    reaportTitleValue = setItemLocalStorage('Bocian.biAuditForm.smadReaportTitle', 'Default reaport');
  }

  $(idInput).val(function() {
     return reaportTitleValue;
  });
}

/**
 * Update data title reaport in storage from input
 */
function updateLocalStorageBiAuditReaportTitle(idInput) {
  $(idInput).keyup(function() {
    delayUpdate(function(){
      var newValue = $(idInput).val();
      setItemLocalStorage('Bocian.biAuditForm.smadReaportTitle', newValue);
      loadCurrentReaportTitleInInput('.smad-reaport-title-pracownicy');
      loadCurrentReaportTitleInInput('.smad-reaport-title-kontrahenci');
    }, 1000 );
  });
}

/**
 * Load data default depth in storage
 */
function loadCurrentDepthInInput(idInput) {
  var depthValue = getItemLocalStorage('Bocian.biAuditForm.depth');

   $(idInput).val(function() {
       return depthValue;
   });
}

/**
 * Update data default depth in storage
 */
function updateLocalStorageBiAuditDepth(idInput) {
  $(idInput).keyup(function() {
    delayUpdate(function(){
      var newValue = $(idInput).val();
      var responseValue = validateValueDepth(parseInt(newValue));

      setItemLocalStorage('Bocian.biAuditForm.depth', responseValue);
      loadCurrentDepthInInput('.smad-depth');
			loadCurrentDepthInInput('.smad-depth-kontrahenci');

			// check depth value
			if ( parseInt(newValue) > 6 ) {
				// check count praconwicy/kontrahenci
					var formItemsPraconwicyKontrahenci = countChoiseItemsPraconwicyKontrahenci();

				// disable button generate reaport if not choise 'praconwicy' or 'kontrahenci'
					if (
						(formItemsPraconwicyKontrahenci.totalPracownicy === 0 && formItemsPraconwicyKontrahenci.totalKontrahenci != 0 ) ||
						(formItemsPraconwicyKontrahenci.totalPracownicy != 0 && formItemsPraconwicyKontrahenci.totalKontrahenci === 0 )
					) {
						p5UI__notifyAjaxCallback({ type: 'error', msg: messageCriticalSearchData });

						$('.bottom--message-warning-critical-search').text(messageCriticalSearchData);

						if(DBG) console.log('popup i dodanie komunikatu niżej');

					} else {
						$('.bottom--message-warning-critical-search').text('');
						if(DBG) console.log('popup i dodanie wyczysc komunikatu ');
					}
			}

    }, 1000 );

  });
}

function validateValueDepth(newValue) {
  var value = null;
  value = newValue;

  if (parseInt(newValue) < 0) {
      value = 1;
  }

  if (parseInt(newValue) > 16) {
    value = 16;
  }

  return value;
}

var delayUpdate = (function() {
  var timer = 0;
  return function(callback, ms) {
  clearTimeout (timer);
  timer = setTimeout(callback, ms);
 };
})();

/**
 * Check count choise pracownicy/kontrahenci
 */
function countChoiseItemsPraconwicyKontrahenci() {
	var countPracownicy = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');
	var countKontrahenci = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');

	var formItems = {
		'totalPracownicy': ((countPracownicy) ? Object.keys(countPracownicy).length : 0),
		'totalKontrahenci': ((countKontrahenci) ? Object.keys(countKontrahenci).length : 0)
	};

	return formItems;
}

/**
 * Załadowanie  wybranej pozycji w select  czy zwracać wyniki tylko z obiektami docelowymi onlyTarget
 */
function loadCurrentOnlyTargetsSelect() {
  var analizaOnlyTargets = getItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets');

	$('#smad-select-target').val(analizaOnlyTargets).attr("selected", "selected");
	$('#smad-select-target-kontrahenci').val(analizaOnlyTargets).attr("selected", "selected");
}

/**
 * Załadowanie do storage informacji czy zwracać wyniki tylko z obiektami docelowymi
 */
function updateLocalStorageBiAuditOnlyTargets(idSelect) {
  $(idSelect).change(function() {

      var newValue = $(idSelect).val();
      var responseValue = newValue;

      setItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets', responseValue);

			$('#smad-select-target').val(newValue).attr("selected", "selected");
			$('#smad-select-target-kontrahenci').val(newValue).attr("selected", "selected");
			// load in select selected option
			loadCurrentOnlyTargetsSelect();
  });
}

function initLocalStorage() {

	if (getItemLocalStorage('Bocian.biAuditForm.pracownicyIds') === null) {
		 setItemLocalStorage('Bocian.biAuditForm.pracownicyIds', []);
	}

	if (getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds') === null) {
		 setItemLocalStorage('Bocian.biAuditForm.kontrahenciIds', []);
	}

	setItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup', 0);
	setItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup', 0);

	if (getItemLocalStorage('Bocian.biAuditForm.depth') === null) {
		updateLocalStorageBiAuditDepth(7);
	}

	if (getItemLocalStorage('Bocian.biAuditForm.smadReaportTitle') === null) {
		updateLocalStorageBiAuditReaportTitle('Default reaport');
	}

	if (getItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets') === null) {
		setItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets', defaultOnlyTarger);
	}
}

/**
 * Funkcja pozwala na wyświetlenie okienka importu
 */
function showViewUploadFile( event, headerTitle, enumType, showCheckbox, csvFileExample ) {
	event.preventDefault();

	var enumType = enumType;

	if( csvFileExample !== undefined) { // przykład + instrukcja do pobrania
			csvFileExample = '<div><a href="'+csvFileExample+'" title="Pobierz przykład" download target="_balnk">Pobierz przykład</a></div>';
	}

	swal({
		title: 'Importuj plik csv',
		input: 'file',
		html: csvFileExample,
		inputAttributes: {
			'accept': 'text/csv',
			'aria-label': 'Upload csv file'
		},
		confirmButtonText: 'Importuj',
		preConfirm: function (file) {
			return new Promise(function (resolve, reject) {
				if (!file) {
					reject("Proszę wybrać plik csv");
					return
				}
				var input = document.querySelector('input[type="file"]');

				var data = new FormData()
				data.append('file', input.files[0])
				data.append('showCheckbox', showCheckbox);

				var responseParseFile = parseCsvFile( data, enumType );
				resolve('file imported')
			})
		},
	}).then(function (result) {
		if(DBG) console.log('result', result);
	}).catch(function (e) {
		if(DBG) console.log('catch: ', e);
	});

}


/**
 * Funkcja przekazuje dane z pliku csv do przeparsowania
 */
function parseCsvFile( fileData, enumType ) {
	event.preventDefault();

	if(DBG) console.log( 'parseCsvFile fileData', fileData);

	fetch(URL_FORM_DATA_CSV_FILE_AJAX, {
	  method: 'POST',
		credentials: 	'same-origin',
	  body: fileData
	})
	.then(function(response) {
	 return response.json()
 }).then(function(json) {

					 swal({
								 title: 'Dane załadowane z pliku CSV',
								 html: json.body.view,
								 width: Math.round(window.innerWidth * 0.9),
								 allowOutsideClick: false, // TODO: btn Anuluj na dole?
								 showCloseButton: true,
								 confirmButtonText: 'Zapisz',
								 preConfirm: function (dataForm) {
						 			return new Promise(function (resolve, reject) {
						 				if (!dataForm) {
						 					reject("Formularz nie zawiera danych do zapisania");
						 					return
						 				}

										// zapisanie danych
						 				var responseSaveData = saveFormCsvFileAjaxAction(enumType);
						 				resolve('data save from form')
						 			})
						 		},
							 }).then(function (result) {

	 							if(DBG) console.log('result', result)
	 						}).catch(function (e) {
	 							if(DBG) console.log('catch: ', e)
	 						});

 }).catch(function(ex) {
	 if(DBG) console.log('parsing failed', ex);
 });
}

/**
 * Funkcja zapisuje dane z formularza do wgrania pliku csv
 */
function saveFormCsvFileAjaxAction(enumType) {
	event.preventDefault();

	var formDataFrom =	$("#formDataFromCsv").serialize();

	formDataFrom = formDataFrom.replace(/%5B/g,"[");
	formDataFrom = formDataFrom.replace(/%5D/g,"]");

	fetch(URL_SAVE_FORM_CSV_FILE_AJAX, {
	  method: 'POST',
		credentials: 	'same-origin',
		headers: {
			'Content-Type': 'application/json'
		},
		body: JSON.stringify({
			 formData: formDataFrom,
			 enumType: enumType
		})
	})
	.then(function(response) {
	 return response.json()
 }).then(function(json) {
	 if(DBG) console.log('parsed json', json);

	 if (response.type == 'success') {

	 	p5UI__notifyAjaxCallback(response.msg);
	 }

	// return json;
 }).catch(function(ex) {
	 if(DBG) console.log('parsing failed', ex);

 });
}


function defaultBIAuditLocalStorage() {
	localStorage.removeItem('Bocian.biAuditForm.pracownicyIds');
	localStorage.removeItem('Bocian.biAuditForm.kontrahenciIds');
	setItemLocalStorage('Bocian.biAuditForm.pracownicy.pagination.page', 1);
	setItemLocalStorage('Bocian.biAuditForm.kontrahenci.pagination.page', 1);
	setItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup', 0);
	setItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup', 0);
	setItemLocalStorage('Bocian.biAuditForm.depth', 7);
	setItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets', defaultOnlyTarger);
}



function generateBiAuditRaport(event) {
	event.preventDefault();

		var pracownicyIdsArray = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');
		var kontrahenciIdsArray = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');
		var depthValue = getItemLocalStorage('Bocian.biAuditForm.depth');
		var smadReaportTitle = getItemLocalStorage('Bocian.biAuditForm.smadReaportTitle');
		var analizaOnlyTargets = getItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets');
		// validate
		if(!smadReaportTitle || smadReaportTitle == '') {
			p5UI__notifyAjaxCallback({ type: 'error', msg: 'Nie podano tytułu raportu' });
		} else if (!depthValue || depthValue === 0) {
			p5UI__notifyAjaxCallback({ type: 'error', msg: 'Nie podano wartości dla głębokości powiązań' });
		} else if ( (!pracownicyIdsArray || pracownicyIdsArray.length === 0) && (!kontrahenciIdsArray || kontrahenciIdsArray.length === 0)	 ) {
			p5UI__notifyAjaxCallback({ type: 'error', msg: 'Nie wybrano pozycji do analizy' });
		} else {
			var generateReaport = true; // generuj raport

			// if not choise 'pracowniocy' or 'kontrahenci'
			if ( (!pracownicyIdsArray || pracownicyIdsArray.length === 0)  || (!kontrahenciIdsArray || kontrahenciIdsArray.length === 0) ) {

				var messageConfirm = '';
				// check selected items
				if ( !pracownicyIdsArray || pracownicyIdsArray.length === 0 ) {
					messageConfirm = 'Nie wybrano osób! Czas przygotowania raportu może wydłużyć się ze względu na sprawdzenie powiązania ze wszystkimi osobami w systemie. Czy jesteś pewny? ';
				}
				if ( !kontrahenciIdsArray || kontrahenciIdsArray.length === 0 )  {
					messageConfirm = 'Nie wybrano podmiotów/kontrahentów! Czas przygotowania raportu może wydłużyć się ze względu na sprawdzenie powiązania ze wszystkimi podmiotami/kontrahentami w systemie. Czy jesteś pewny? ';
				}

				// show confirm window with message
				if (confirm(messageConfirm)) {
	    		generateReaport = true;
				} else { // cancel
					generateReaport = false;
				}
			}

			if (generateReaport === true) {
				// send
				window.fetch(URL_GENERATE_BI_AUDIT_RAPORT_AJAX, {
					  method: 'POST',
					  headers: {
					    'Content-Type': 'application/json'
					  },
						credentials: 'same-origin',
					  body: JSON.stringify({
					     pracownicyIds: pracownicyIdsArray,
					     kontrahenciIds: kontrahenciIdsArray,
					     depthValue: depthValue,
							 smadReaportTitle: smadReaportTitle,
							 analizaOnlyTargets: analizaOnlyTargets
					  })
					})
					.then(function(response) {
						if(DBG) console.log('Firsst then', response);

						return response.text();
					})
					.then(function(responseText) {
						try {
							return JSON.parse(responseText);
						} catch (e) {
							throw responseText;
						}
					})
					.then(function(result) {

						if (result.type == 'success') {

							p5UI__notifyAjaxCallback(result);
							defaultBIAuditLocalStorage();
							updateTopCounters();
							// unchecked checkbox pracownicy
							$('#smad-table-PRACOWNICY form').find(':checkbox').prop('checked', false);
							// unchecked checkbox kontrahenci
							$('#smad-table-KONTRAHENCI form').find(':checkbox').prop('checked', false);
							//
							$('#count-selected-item-kontrahenci').text('0');
							$('#count-selected-item-pracownicy').text('0');
							$('.bottom--message-warning-critical-search').text('');
							swal({
	 								 title: result.msg,
	 								 html: '<a href="' + BASE_URLS + 'index.php?_route=ViewTableAjax&amp;namespace=default_db/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA" title="przejdź do raportów" >Przejdź do raportów</a>',
	 								 allowOutsideClick: false, // TODO: btn Anuluj na dole?
	 								 showCloseButton: true,
	 								 confirmButtonText: 'OK',
	 	 						});

							window.setTimeout(URL_TABLE_POWIAZANIA, 6000);
							resolve(result.msg);


						} else {
							reject(result.msg);
						}
					})
					.catch(function(error) {
						if(DBG) console.log('request failed', error);
					});
			}

		}
}

/**
* Dodaj nowego pracownika
*/
function createPracownikAjax(event) {
	event.preventDefault();

	swal({
	  title: 'Dodaj osobę',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  html:
		'<div class="form-group">'+
    '<input class="form-control required" id="personName" placeholder="Imię" >' +
    '<input class="form-control required" id="personSurname" placeholder="Nazwisko">'+
		'<input class="form-control required" id="personNip" placeholder="NIP">'+
		'<input class="form-control required" id="personPesel" placeholder="PESEL">'+
		'<input class="form-control required" id="personRegon" placeholder="REGON">'+
		'</div>',
	   preConfirm: () => {
	    return new Promise(function (resolve, reject) {

				// data from form
				var personName = $('#personName').val();
				var personSurname = $('#personSurname').val();
				var personNip = $('#personNip').val();
				var personPesel = $('#personPesel').val();
				var personRegon = $('#personRegon').val();

				//validate data from input
				if (!personName){
					reject('Proszę podać imię')
					return;
				}
				if (!personSurname){
					reject('Proszę podać nazwisko')
					return;
				}
				window.fetch(URL_CREATE_PRACOWNICY, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'personName': personName,
						'personSurname': personSurname,
						'personNip': personNip,
						'personPesel': personPesel,
						'personRegon': personRegon
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {

					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.body);
						urlFetchPracownicy(1);
					}
				})
				.catch(function(error) {
					if(DBG) console.log('request failed', error);
				})

	    })
	  },
	  allowOutsideClick: false
	}).then(function (createPerson) {
		 if(DBG) console.log('dodanie osoby: ', createPerson);

	});
}

/**
* Dodaj nowego kontrahenta
*/
function createKontrahentAjax(event) {
	event.preventDefault();

	swal({
	  title: 'Dodaj podmiot/kontrahenta',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  html:
		'<div class="form-group">'+
    '<input class="form-control required" id="companyFullName" placeholder="Pelna nazwa" >' +
    '<input class="form-control required" id="companyShortName" placeholder="Skrócona nazwa\">'+
		'<input class="form-control required" id="companyNameGroup" placeholder="Nazwa grupy kapitałowej">'+
		'<input class="form-control required" id="companyKrs" placeholder="KRS">'+
		'<input class="form-control required" id="companyNip" placeholder="NIP">'+
		'<input class="form-control required" id="companyPesel" placeholder="PESEL">'+
		'<input class="form-control required" id="companyFax" placeholder="FAX">'+
		'<input class="form-control required" id="companyTelefon" placeholder="Telefon">'+
		'<input class="form-control required" id="companyMail" placeholder="Mail">'+
		'<input class="form-control required" id="companyStreet" placeholder="Ulica">'+
		'<input class="form-control required" id="companyNumberBuilding" placeholder="Numer budynku">'+
		'<input class="form-control required" id="companyNumberLocal" placeholder="Numer mieszkania /lokalu">'+
		'<input class="form-control required" id="companyPostCode" placeholder="Kod pocztowy">'+
		'<input class="form-control required" id="companyPlace" placeholder="Miejscowosc">'+
		'<input class="form-control required" id="companyCountry" placeholder="Kraj">'+
		'<input class="form-control required" id="companyTypeCompany" placeholder="Typ kontrahenta">'+
		'<input class="form-control required" id="companyTitleDocument" placeholder="Tytul dokumentu">'+
		'<input class="form-control required" id="companyDesc" placeholder="uwagi">'+
		'</div>',

	   preConfirm: () => {
	    return new Promise(function (resolve, reject) {

				// data from form
				var companyFullName = $('#companyFullName').val();
				var companyShortName = $('#companyShortName').val();
				var companyNameGroup = $('#companyNameGroup').val();
				var companyKrs = $('#companyKrs').val();
				var companyNip = $('#companyNip').val();
				var companyPesel = $('#companyPesel').val();
				var companyFax = $('#companyFax').val();
				var companyTelefon = $('#companyTelefon').val();
				var companyMail = $('#companyMail').val();
				var companyStreet = $('#companyStreet').val();
				var companyNumberBuilding = $('#companyNumberBuilding').val();
				var companyNumberLocal = $('#companyNumberLocal').val();
				var companyPostCode = $('#companyPostCode').val();
				var companyPlace = $('#companyPlace').val();
				var companyCountry = $('#companyCountry').val();
				var companyTypeCompany = $('#companyTypeCompany').val();
				var companyTitleDocument = $('#companyTitleDocument').val();
				var companyDesc = $('#companyDesc').val();


				//validate data from input
				if (!companyFullName){
					reject('Proszę podać pełną nazwę');
					return;
				}

				window.fetch(URL_CREATE_KONTRAHENCI, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'companyFullName': companyFullName,
						'companyShortName': companyShortName,
						'companyNameGroup': companyNameGroup,
						'companyKrs': companyKrs,
						'companyNip': companyNip,
						'companyPesel': companyPesel,
						'companyFax': companyFax,
						'companyTelefon': companyTelefon,
						'companyMail': companyMail,
						'companyStreet': companyStreet,
						'companyNumberBuilding': companyNumberBuilding,
						'companyNumberLocal': companyNumberLocal,
						'companyPostCode': companyPostCode,
						'companyPlace': companyPlace,
						'companyCountry': companyCountry,
						'companyTypeCompany': companyTypeCompany,
						'companyTitleDocument': companyTitleDocument,
						'companyDesc': companyDesc
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {

					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.body);
						urlFetchKontrahenci(1);
					}
				})
				.catch(function(error) {
					if(DBG) console.log('request failed', error);
				})

	    })
	  },
	  allowOutsideClick: false
	}).then(function (createPerson) {
		 if(DBG) console.log('dodanie podmiotu: ', createPerson);

	});
}

/**
 * Popup z opcja przeniesienia pracowników do innej grupy
 */
function addPracownikToGroup(event) {
	event.preventDefault();

	var pracownicyIdsArray = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');
	if (pracownicyIdsArray === null || !pracownicyIdsArray || !pracownicyIdsArray.length) {
		showTextListIdPracownikow = 'nie wybrano osób';
	} else {
		showTextListIdPracownikow = '' + pracownicyIdsArray.length + ' osób';
	}

	var arrayGroupOptions = [];
	var listGroupStorage = getItemLocalStorage('Bocian.biAuditForm.pracownicy.groups');
  // utworzenie tablicy Optionsów grupy
	listGroupStorage.map(function(item) {
		if (item.ID !== undefined) {
			arrayGroupOptions[item.ID] = item.NAZWA;
		}
	});

	swal({
	  title: 'Dodaj do grupy',
		input: 'select',
		text: showTextListIdPracownikow,
	  inputOptions: arrayGroupOptions,
	  inputPlaceholder: 'Wybierz grupę',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  preConfirm: function (idGroup) {
	    return new Promise(function (resolve, reject) {
				if(DBG) console.log('idGrupy value', idGroup);

				if ( !pracownicyIdsArray || pracownicyIdsArray === null || pracownicyIdsArray === 'undefined' ) {
						reject('Wybierz pracowników');
				} else if ( pracownicyIdsArray.length === 0 ) {
					reject('Wybierz pracowników');
				}
				if (!idGroup) reject('Proszę wybrać nazwę grupy');

				window.fetch(URL_ADD_PRACOWNICY_TO_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'idGroup': idGroup,
						'pracownicyIds': getItemLocalStorage('Bocian.biAuditForm.pracownicyIds'),
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {

					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.msg);
					} else {
						reject(result.msg);
					}
				})
				.catch(function(error) {
					if(DBG) console.warn('request failed', error);
				});
	    })
	  },
	  allowOutsideClick: false
	}).then(function (groupPracownicyData) {
		//TODO: pIOTRKU CZY TU POWINIENEM COŚ JESZCZE OBSŁUŻYĆ
	});
}

function addPracownikAllToGroup(event) {
	event.preventDefault();

	var showTextListIdPracownikow = 'wszystkich pracowników pasujących do kryteriów wyszukiwania';

	var arrayGroupOptions = [];
	var listGroupStorage = getItemLocalStorage('Bocian.biAuditForm.pracownicy.groups');
  // utworzenie tablicy Optionsów grupy
	listGroupStorage.map(function(item) {
		if (item.ID !== undefined) {
			arrayGroupOptions[item.ID] = item.NAZWA;
		}
	});

	swal({
	  title: 'Dodaj do grupy',
		input: 'select',
		text: showTextListIdPracownikow,
	  inputOptions: arrayGroupOptions,
	  inputPlaceholder: 'Wybierz grupę',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  preConfirm: function (idGroup) {
	    return new Promise(function (resolve, reject) {
				if (!idGroup) {
					reject('Proszę wybrać nazwę grupy');
					return;
				}

				var filterFields = {}
				var frm = document.getElementById('filtersFieldRemoveBtn-PRACOWNICY').form
				var fieldNameList = FIELD_LIST_PRACOWNICY
				fieldNameList.filter(function (fieldName) {
					if (!frm[fieldName] && DBG) console.log('Err missing field: "'+fieldName+'"');
					return (frm[fieldName]) ? true : false
				}).map(function (fieldName) {
					return [ fieldName, frm[fieldName].value ]
				}).filter(function (filter) {
					return ( filter[1].length > 0 )
				}).map(function (filter) {
					filterFields[ filter[0] ] = filter[1]
				})
				var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup');
				if (filterIdGroup) filterFields[ 'filterIdGroup' ] = filterIdGroup

				window.fetch(URL_ADD_PRACOWNICY_TO_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'idGroup': idGroup,
						'type': 'filter',
						'filter': filterFields,
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {

					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.msg);
					} else {
						reject(result.msg);
					}
				})
				.catch(function(error) {
					if(DBG) console.log('request failed', error);
				});
	    })
	  },
	  allowOutsideClick: false
	}).then(function (groupPracownicyData) {
		//TODO: pIOTRKU CZY TU POWINIENEM COŚ JESZCZE OBSŁUŻYĆ
	});
}

/**
 * Popup z opcja przeniesienia kontrahentów do innej grupy
 */
function addKontrahenciToGroup(event) {
	event.preventDefault();

	var kontrahenciIdsArray = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');
	if (kontrahenciIdsArray === null || !kontrahenciIdsArray || !kontrahenciIdsArray.length) {
		showTextListIdKontrahentow = 'nie wybrano kontrahentów';
	} else {
		showTextListIdKontrahentow = '' + kontrahenciIdsArray.length + ' podmiotów/kontrahentów';
	}

	var arrayGroupOptions = [];
	var listGroupStorage = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.groups');
  // utworzenie tablicy Optionsów grupy
	listGroupStorage.map(function(item) {
		if (item.ID !== undefined) {
	   	arrayGroupOptions[item.ID] = item.NAZWA;
		}
	});

	swal({
	  title: 'Dodaj do grupy',
		input: 'select',
		text: showTextListIdKontrahentow,
	  inputOptions: arrayGroupOptions,
	  inputPlaceholder: 'Wybierz grupę',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  preConfirm: function (idGroup) {
	    return new Promise(function (resolve, reject) {

				if (!idGroup) {
					reject('Proszę wybrać nazwę grupy');
					return;
				}
				if (!kontrahenciIdsArray || !kontrahenciIdsArray.length) {
					reject('Wybierz kontrahentów');
					return;
				}

				window.fetch(URL_ADD_KONTRAHENCI_TO_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'idGroup': idGroup,
						'kontrahenciIds': getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds'),
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {
					result
					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.msg);
					} else {
						reject(result.msg);
					}
				})
				;
	    })
	  },
	  allowOutsideClick: false
	}).then(function (groupKontrahenciData) {
		//TODO: PIOTRKU CZY TU POWINIENEM COŚ JESZCZE OBSŁUŻYĆ
	});
}
function addKontrahenciAllToGroup(event) {
	event.preventDefault();

	var kontrahenciIdsArray = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');

	var showTextListIdKontrahentow = 'wszystkich podmotów/kontrahentów pasujących do kryteriów wyszukiwania';

	var arrayGroupOptions = [];
	var listGroupStorage = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.groups');
  // utworzenie tablicy Optionsów grupy
	listGroupStorage.map(function(item) {
		if (item.ID !== undefined) {
			arrayGroupOptions[item.ID] = item.NAZWA;
		}
	});

	swal({
	  title: 'Dodaj do grupy',
		input: 'select',
		text: showTextListIdKontrahentow,
	  inputOptions: arrayGroupOptions,
	  inputPlaceholder: 'Wybierz grupę',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  preConfirm: function (idGroup) {
	    return new Promise(function (resolve, reject) {
				if (!idGroup) {
					reject('Proszę wybrać nazwę grupy');
					return;
				}

				var filterFields = {}
				var frm = document.getElementById('filtersFieldRemoveBtn-KONTRAHENCI').form
				var fieldNameList = FIELD_LIST_KONTRAHENCI
				fieldNameList.filter(function (fieldName) {
					if (!frm[fieldName] && DBG) console.log('Err missing field: "'+fieldName+'"')
					return (frm[fieldName]) ? true : false
				}).map(function (fieldName) {
					return [ fieldName, frm[fieldName].value ]
				}).filter(function (filter) {
					return ( filter[1].length > 0 )
				}).map(function (filter) {
					filterFields[ filter[0] ] = filter[1]
				})
				var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup');
				if (filterIdGroup) filterFields[ 'filterIdGroup' ] = filterIdGroup

				window.fetch(URL_ADD_KONTRAHENCI_TO_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'idGroup': idGroup,
						'type': 'filter',
						'filter': filterFields,
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {
					$('#smad-table-PRACOWNICY form').find(':checkbox').prop('checked', false);
					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.msg);
					} else {
						reject(result.msg);
					}
				})
				.catch(function(error) {
					if(DBG) console.log('request failed', error);
				});
	    })
	  },
	  allowOutsideClick: false
	});
}

function removeKontrahenciFromGroup(event){
	event.preventDefault;

	var kontrahenciIdsArray = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');
	if (kontrahenciIdsArray === null || !kontrahenciIdsArray || !kontrahenciIdsArray.length) {
		showTextListIdKontrahentow = 'nie wybrano kontrahentów';
	} else {
		showTextListIdKontrahentow = '' + kontrahenciIdsArray.length + ' podmiotów/kontrahentów';
	}

	var groupId = localStorage.getItem("Bocian.biAuditForm.kontrahenci.filterIdGroup");
	var removeTitle = "Czy chcesz usunąć z "
	if(groupId === "0"){
		removeTitle+= "systemu";
	} else {
		var arrayGroupOptions = [];
		var listGroupStorage = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.groups');
	  // utworzenie tablicy Optionsów grupy
		listGroupStorage.map(function(item) {
			if (item.ID !== undefined) {
				arrayGroupOptions[item.ID] = item.NAZWA;
			}
		});
		removeTitle+= "grupy ";
		removeTitle+= arrayGroupOptions[groupId];
	}
	swal({
	  title: removeTitle,
		text: showTextListIdKontrahentow,
	  showCancelButton: true,
	  confirmButtonText: 'Submit',
	  showLoaderOnConfirm: true,
		preConfirm: function () {
	    return new Promise(function (resolve, reject) {

				if (!kontrahenciIdsArray || !kontrahenciIdsArray.length) {
					reject('Wybierz kontrahentów');
					return;
				}

				window.fetch(URL_REMOVE_KONTRAHENCI_FROM_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'idGroup': getItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup'),
						'kontrahenciIds': getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds'),
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {
					result
					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						defaultBIAuditLocalStorage();
						updateTopCounters();
						$('#smad-table-KONTRAHENCI form').find(':checkbox').prop('checked', false);
						resolve(result.msg);
					} else {
						reject(result.msg);
					}
				})
				;
	    })
	  },
	  allowOutsideClick: false
	}).then((result) => {

	});
}

function removePracownikFromGroup(event){
	event.preventDefault;

	var pracownicyIdsArray = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');
	if (pracownicyIdsArray === null || !pracownicyIdsArray || !pracownicyIdsArray.length) {
		showTextListIdPracownikow = 'nie wybrano osób';
	} else {
		showTextListIdPracownikow = '' + pracownicyIdsArray.length + ' osób';
	}
	var groupId = localStorage.getItem("Bocian.biAuditForm.pracownicy.filterIdGroup");
	var removeTitle = "Czy chcesz usunąć z "
	if(groupId === "0"){
		removeTitle+= "systemu";
	} else {
		var arrayGroupOptions = [];
		var listGroupStorage = getItemLocalStorage('Bocian.biAuditForm.pracownicy.groups');
	  // utworzenie tablicy Optionsów grupy
		listGroupStorage.map(function(item) {
			if (item.ID !== undefined) {
				arrayGroupOptions[item.ID] = item.NAZWA;
			}
		});
		removeTitle+= "grupy ";
		removeTitle+= arrayGroupOptions[groupId];
	}
	swal({
	  title: removeTitle,
		text: showTextListIdPracownikow,
	  showCancelButton: true,
	  confirmButtonText: 'Submit',
	  showLoaderOnConfirm: true,
		preConfirm: function () {
	    return new Promise(function (resolve, reject) {

				if (!pracownicyIdsArray || !pracownicyIdsArray.length) {
					reject('Wybierz osoby');
					return;
				}

				window.fetch(URL_REMOVE_PRACOWNICY_FROM_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'idGroup': getItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup'),
						'pracownicyIds': getItemLocalStorage('Bocian.biAuditForm.pracownicyIds'),
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {
					result
					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						defaultBIAuditLocalStorage();
						updateTopCounters();
						$('#smad-table-PRACOWNICY form').find(':checkbox').prop('checked', false);
						resolve(result.msg);
					} else {
						reject(result.msg);
					}
				})
				;
	    })
	  },
	  allowOutsideClick: false
	}).then((result) => {

	});

}

function createGroupKontrahenci(event) {
	event.preventDefault();

	swal({
	  title: 'Utwórz grupę',
	  input: 'text',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  preConfirm: function (NAZWA) {
	    return new Promise(function (resolve, reject) {
				if (!NAZWA) reject('Proszę podać nazwę grupy');

				window.fetch(URL_CREATE_KONTRAHENCIS_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'NAZWA': NAZWA
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {

					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.body);
					} else {

						reject("Proszę podać inną nazwę grupy");
					}
				})
				.catch(function(error) {
					if(DBG) 	console.log('request failed', error);
				})
	    })
	  },
	  allowOutsideClick: false
	}).then(function (groupKontrahenciData) {
			//TODO: aktualizacja fitrów na widoku -> SPrawdzić co dostaniemy w odpowiedzi po dodaniu filtra grupy
			groupsKontrahenci = '<button class="btn btn-default" title="'+groupKontrahenciData['nazwa']+'" data-group-filter="'+groupKontrahenciData['id']+'">'+groupKontrahenciData['nazwa']+'</button>';
			$('#group-kontrahenci').append(groupsKontrahenci);
	});

}

function createGroupPracownicy(event) {
	event.preventDefault();

	swal({
	  title: 'Utwórz grupę',
	  input: 'text',
	  showCancelButton: true,
	  confirmButtonText: 'Zapisz',
	  showLoaderOnConfirm: true,
	  preConfirm: function (NAZWA) {
	    return new Promise(function (resolve, reject) {
				if (!NAZWA) reject('Proszę podać nazwę grupy');

				window.fetch(URL_CREATE_PRACOWNICY_GROUP, {
					method: 'POST',
					header: {
						'contentType': 'applications/json'
					},
					credentials: 'same-origin',
					body: JSON.stringify({
						'NAZWA': NAZWA
					})
				})
				.then(function(response) {
					return response.text();
				})
				.then(function(responseText) {

					try {
						return JSON.parse(responseText);
					} catch (e) {
						throw responseText;
					}
				})
				.then(function(result) {

					if (result.type == 'success') {
						p5UI__notifyAjaxCallback(result);
						resolve(result.body);
					} else {
						reject("Proszę podać inną nazwę grupy");
					}
				})
				.catch(function(error) {
					if(DBG) console.log('request failed', error);
				})

	    })
	  },
	  allowOutsideClick: false
	}).then(function (groupPracownicyData) {
		if(DBG) console.log('grupa prac2: ', groupPracownicyData);

		//TODO: aktualizacja fitrów na widoku -> SPrawdzić co dostaniemy w odpowiedzi po dodaniu filtra grupy
		groupsPracownicy = '<button class="btn btn-default" title="'+groupPracownicyData['nazwa']+'" data-group-filter="'+groupPracownicyData['id']+'">'+groupPracownicyData['nazwa']+'</button>';
		$('#group-pracownicy').append(groupsPracownicy);

	});

}

/**
 * Function for load view Form pracownicy/kontrahenci
 */
function rootChangeForm() {

//todo: do przeniesienia
urlFetchKontrahenciPowiazania();
	var valueUrl = global.location.hash;

	switch (valueUrl) {
		case '#KONTRAHENCI':
			$( ".container-bi_audit_form_kontrahenci_raport" ).html( VIEW_KONTRAHENCI );
			urlFetchKontrahenci(1);
			fetchGroupKontrahenci();
			$( ".container-bi_audit_form_pracownicy_raport" ).hide();
			$( ".container-bi_audit_form_kontrahenci_raport" ).show();
			//parseGraph();
			break;

		case '#PRACOWNICY':
		$( ".container-bi_audit_form_pracownicy_raport" ).html( VIEW_PRACOWNICY );
			urlFetchPracownicy(1);
			fetchGroupPracownicy();
			$( ".container-bi_audit_form_kontrahenci_raport" ).hide();
			$( ".container-bi_audit_form_pracownicy_raport" ).show();
			break;

		// case '#REAPORT':
		// 	$( ".container-bi_audit_form_raport_data" ).html( VIEW_TREE_REAPORT );
		// 	urlFetchKontrahenciPowiazania();
		// 	$( ".container-bi_audit_form_kontrahenci_raport" ).hide();
		// 	$( ".container-bi_audit_form_pracownicy_raport" ).hide();
		// 	$( ".container-bi_audit_form_raport_data" ).show();
		// break;

		default:
		$( ".container-bi_audit_form_pracownicy_raport" ).html( VIEW_PRACOWNICY );
			urlFetchPracownicy(1);
			fetchGroupPracownicy();
			$( ".container-bi_audit_form_kontrahenci_raport" ).hide();
			$( ".container-training" ).hide();
			$( ".container-about" ).hide();
			$( ".container-bi_audit_form_pracownicy_raport" ).show();
		break;
	}

	// pobranie defaultowego tytułu dla generowanego raportu
	loadCurrentReaportTitleInInput('.smad-reaport-title-pracownicy');
	loadCurrentReaportTitleInInput('.smad-reaport-title-kontrahenci');
	// aktualizacja inputów defaultowego tytułu dla generowanego raportu
	updateLocalStorageBiAuditReaportTitle('.smad-reaport-title-pracownicy');
	updateLocalStorageBiAuditReaportTitle('.smad-reaport-title-kontrahenci');

	//aktualizacja inputa głebokości powiazan
	loadCurrentDepthInInput('.smad-depth');
	loadCurrentDepthInInput('.smad-depth-kontrahenci');

	updateLocalStorageBiAuditDepth('.smad-depth');
	updateLocalStorageBiAuditDepth('.smad-depth-kontrahenci');
	// aktualizacja select option czy zwracać wyniki tylko z obiektami docelowymi
	updateLocalStorageBiAuditOnlyTargets('#smad-select-target');
	updateLocalStorageBiAuditOnlyTargets('#smad-select-target-kontrahenci');
	// load in select selected option BI_analiza_onlyTargets
	loadCurrentOnlyTargetsSelect();

}

function getAddressData(objectValue) {

	var objectValue = objectValue || [];
	var listData = '';

	if (!objectValue) {
		return true;
	}

	objectValue.forEach (function(item) {
		if (item['kodPocztowy']) { listData += '<div>kod pocztowy: ' + item['kodPocztowy'] + '<div>'; }
		if (item['miejscowosc']) { listData += '<div>miejscowość: ' + item['miejscowosc'] + '<div>'; }
		if (item['nrBudynku']) { listData += '<div>nr budynku: ' + item['nrBudynku'] + '<div>'; }
		if (item['nrLokalu']) { listData += '<div>nr lokalu: ' + item['nrLokalu'] + '<div>'; }
		if (item['typAdresu']) { listData += '<div>typ adresu: ' + item['typAdresu'] + '<div>'; }
		if (item['ulica']) { listData += '<div>ulica: ' + item['ulica'] + '<div>'; }
		listData += '<div>------<div>';
	});

	return listData;
}


/**
 *  Get name name group
 */
function getNameGroupById(store, filterIdGroup) {

	var NAZWA = '';
	if (!store || filterIdGroup === 0 ) {
		NAZWA = 'Wszyscy';
	} else {

		$(store).each(function() {
				if ( parseInt(filterIdGroup) === parseInt(this.ID) ) {
					NAZWA = this.NAZWA;
				}
		});
	}

	return NAZWA;
}


function urlFetchKontrahenci(page) {
	hideMoreRecordFunctionsPopover()
			var page = page || getItemLocalStorage('Bocian.biAuditForm.kontrahenci.pagination.page');

			selectPage('KONTRAHENCI', page);

			if ( page === 1) {
				setItemLocalStorage('Bocian.biAuditForm.kontrahenci.pagination.page', 1);
			}

			var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup');

			var frm = document.getElementById('filtersFieldRemoveBtn-KONTRAHENCI').form
			var fieldNameList = FIELD_LIST_KONTRAHENCI
			var filterFields = fieldNameList.map(function (fieldName) {
				return [ fieldName, frm[fieldName].value ]
			}).filter(function (filter) {
				return ( filter[1].length > 0 )
			}).map(function (filter) {
				return '' + filter[0] + '=' + filter[1]
			}).join('&')
			filterFields = (filterFields.length > 0) ? '&' + filterFields : ''

			fetch(URL_FETCH_KONTRAHENCI + '&page=' + page + '&filterIdGroup=' + filterIdGroup + filterFields, {
					credentials: 'same-origin'
				})
				.then(function parseJSON(response) {
					return response.json()

				var filterIdGroup = filterIdGroup || getItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup');
						})
				.then(function(data) {


						var listItemsKontrahenci = null;
						data.body.items.forEach (function(row) {
							listItemsKontrahenci += '<tr><td style="white-space:nowrap">' +
									'<input style="vertical-align:top" type="checkbox" name="kontrID[]" value="'+row['ID']+'" />' +
									'<i onClick="kontrahenciLoadMoreRecordFunctions(event, this, '+row['ID']+')" style="margin-left:6px; cursor:pointer; color:#333" class="glyphicon glyphicon-menu-hamburger" title="Więcej funkcji dla rekordu nr ' + row['ID'] + '"></i>' +
								'</td>' +
								'<td align="right">'+row["ID"]+'</td>'+
								'<td align="right">' + ( row["Nazwa_grupy_kapitalowej"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Pelna_nazwa_kontrahenta"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Numer_kontrahenta"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Skrocona_Nazwa_Kontrahenta"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Typ_kontrahenta"] || '' ) + '</td>' +
								'<td align="right">' + ( row["NIP"] || '' ) + '</td>' +
								'<td align="right">' + ( row["KRS"] || '' ) + '</td>' +
								'<td align="right">' + ( row["REGON"] || '' ) + '</td>' +
								'<td align="right">' + ( row["PESEL"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Forma_prawna_dzialalnosci"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Ulica"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Numer_budynku"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Numer_mieszkania_lokalu"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Miejscowosc"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Kod_pocztowy"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Kraj"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Telefon"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Fax"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Mail"] || '' ) + '</td>' +
								'<td align="right">' + ( row["A_ADM_COMPANY"] || '' ) + '</td>' +
								'<td align="right">' + ( row["A_CLASSIFIED"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Dodano"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Podmiot_dominujacy"] || '' ) + '</td>' +
								'<td align="right">' + ( row["Tytul_dokumentu"] || '' ) + '</td>' +
								'<td align="right">' + ( row["ownCompany"] || '' ) + '</td>' +
								'<td align="right">' + ( row["uwagi"] || '' ) + '</td></tr>';
						});

				if (data.body.pagination !== undefined) {
					Pagination.Init(document.getElementById('pagination-kontrahenci'), {
							url: BASE_URLS+'index.php?_route=UrlAction_Bocian#KONTRAHENCI',
							id_pagination: 'pagination-kontrahenci',
							type: 'KONTRAHENCI',
							limit: data.body.pagination.limit,
							total_items: data.body.pagination.total_items, // pages size
							size: data.body.pagination.size, // pages size
							page: page,  // selected page
							step: 1   // pages before and after current
					});

					var paginationShowNextCount = 1;
					if ( parseInt(data.body.pagination.current) !== 1) {
						 paginationShowNextCount = parseInt(data.body.pagination.limit) * (parseInt(data.body.pagination.current) - 1 ) + 1;
					}
					$('#paginationShowNextCount-KONTRAHENCI').text(paginationShowNextCount);
					$('#smad-filter-desc-kontrahenci').text(data.body.pagination.total_items);
					if (data.body.pagination.total_items > 0) {
						var btnGraphView = $('<button class="btn btn-primary smad-kontrahenci-graph-button" onClick="graphShowHide(\'kontrahenci\')" style="padding:1px 5px; margin-left:12px">GRAF POWIĄZAŃ</button>')

						var btnAddAll = $('<button class="btn btn-primary" style="padding:1px 5px; margin-left:12px">DODAJ WSZYSTKIE DO ANALIZY</button>')
						btnAddAll.on('click', { pagination: data.body.pagination }, function (event) {
							// event.data.pagination: { [ filter_idGroup: ... ] }
							// fetch ids from request, set to LocatStorage, update selected on gui
							var postData = {}
							if ('filter_idGroup' in event.data.pagination && event.data.pagination['filter_idGroup']) postData['filter_idGroup'] = event.data.pagination['filter_idGroup']
							Object.keys(event.data.pagination).filter(function (key) {
								return ('f_' === key.substr(0, 2))
							}).forEach(function (filterKey) {
								var value = event.data.pagination[filterKey]
								postData[filterKey] = value
							})
							var thisButton = $(this)
							thisButton.attr('disabled', true)
							thisButton.text( thisButton.text() + '...' )
							p5UI__notifyAjaxCallback({ type: 'info', msg: "Pobieranie podmiotów/kontrahentów..." })
							global.fetch(URL_FETCH_KONTRAHENCI_IDS_AJAX, {
								credentials: 'same-origin',
								method: 'POST',
								headers: {
									'Content-Type': 'application/json'
								},
								body: JSON.stringify(postData)
							})
							.then(function __parseJSON(response) {
								return response.json()
							})
							.then(function (json) {
								if ('success' === json.type && json.body && json.body.ids) {
									updateListIdBiAuditReaport('KONTRAHENCI', json.body.ids.map(function (id) {
										return parseInt(id)
									}))
									jQuery('#body-kontrahenci').find('input[name="kontrID[]"]').attr('checked', true)
									thisButton.attr('disabled', false)
									var txt = thisButton.text()
									thisButton.text( '...' === txt.substr(-3) ? txt.substr(0, txt.length - 3) : txt )
									p5UI__notifyAjaxCallback({ type: 'success', msg: "Dodano "+json.body.ids.length+" kontrahentów" })
								}
							})
							.catch(function (e) {
								p5UI__notifyAjaxCallback({ type: 'error', msg: '' + e })
								thisButton.attr('disabled', false)
								var txt = thisButton.text()
								thisButton.text( '...' === txt.substr(-3) ? txt.substr(0, txt.length - 3) : txt )
							})
						})
						$('#smad-filter-desc-kontrahenci').append(btnAddAll);
						$('#smad-filter-desc-kontrahenci').append(btnGraphView);
					}
				}

				var groupSelectData = getNameGroupById(getItemLocalStorage('Bocian.biAuditForm.kontrahenci.groups'), filterIdGroup);
				$('#smad-filter-head-title-kontrahenci').text(groupSelectData);
				if(DBG) console.log('kontrahenci groupSelectData: ', groupSelectData);


				$( "#body-kontrahenci" ).html(listItemsKontrahenci);
				checkAll('KONTRAHENCI');
				catchEventCheckbox('KONTRAHENCI');
				checkedChoiseItems('KONTRAHENCI', getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds') );

				//	$( ".container-bi_audit_raport" ).append( data.body.view );
					if(DBG) console.log('request succeeded with JSON responseKontrahenci', data)

					updateTopCounters();
				}).catch(function(error) {
					if(DBG) console.log('request failed', error);
				})
}

function urlFetchPracownicy(page) {
	hideMoreRecordFunctionsPopover()
		var page = page || getItemLocalStorage('Bocian.biAuditForm.pracownicy.pagination.page');

		if ( page === 1) {
			setItemLocalStorage('Bocian.biAuditForm.pracownicy.pagination.page', 1);
		}

			var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup');

			selectPage('PRACOWNICY', page);

			var frm = document.getElementById('filtersFieldRemoveBtn-PRACOWNICY').form
			var fieldNameList = FIELD_LIST_PRACOWNICY
			var filterFields = fieldNameList.filter(function (fieldName) {
				if (!frm[fieldName] && DBG) console.log('Err missing field: "'+fieldName+'"')
				return (frm[fieldName]) ? true : false
			}).map(function (fieldName) {
				return [ fieldName, frm[fieldName].value ]
			}).filter(function (filter) {
				return ( filter[1].length > 0 )
			}).map(function (filter) {
				return '' + filter[0] + '=' + filter[1]
			}).join('&')
			filterFields = (filterFields.length > 0) ? '&' + filterFields : ''

			var paginationLimit = 20;
			/*p5WFS_GetFeature('default_db__x3A__BI_audit_ENERGA_PRACOWNICY:BI_audit_ENERGA_PRACOWNICY',
				Object.assign({
					sortBy: 'ID+D',
					maxFeatures: paginationLimit,
					startIndex: (page - 1) * paginationLimit,
					// TODO: backRefNS, backRefPK, backRefField - TODO: from groups
					// resolve: 'all',
					// resolveDepth: 2
					'ogc:Filter': '<wfs:Query>' + '\n' + [
						'*',
						'default_db__x3A__BI_audit_ENERGA_PRACOWNICY_adresy:BI_audit_ENERGA_PRACOWNICY_adresy/*',
						[
							'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
							'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row',
							'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
							'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI:BI_audit_ENERGA_RUM_KONTRAHENCI'
						].join('/')
					].map(function (fieldName) {
						return '<wfs:PropertyName>' + fieldName + '</wfs:PropertyName>';
					}).join('\n') + '\n' + '</wfs:Query>'
				}, (filterIdGroup > 0)
					? {
							backRefNS: 'default_db/BI_audit_ENERGA_PRACOWNICY_group/BI_audit_ENERGA_PRACOWNICY_group',
							backRefPK: filterIdGroup,
							backRefField: 'default_db__x3A__BI_audit_ENERGA_PRACOWNICY:BI_audit_ENERGA_PRACOWNICY',
						}
					: {}
				)
			).then(function (items) {
				if(DBG)console.log('p5WFS_GetFeature: items: ', items);
			}).catch(function (err) {
				if(DBG)console.log('p5WFS_GetFeature: err: ', err);
			})*/

			fetch(URL_FETCH_PRACOWNICY + '&page=' + page + '&filterIdGroup=' + filterIdGroup + filterFields, {
				credentials: 'same-origin'
			})
			.then(function parseJSON(response) {
			  return response.json()
			})
			.then(function(data) {

					var addresPerson = '';
					var listItemsPracownik = null;
					if(DBG) console.log('urlFetchPracownicy', data.body.items);

					data.body.items.forEach (function(row) {

						if (row["default_db__x3A__BI_audit_ENERGA_PRACOWNICY_adresy:BI_audit_ENERGA_PRACOWNICY_adresy"]) {
							addresPerson = getAddressData(row["default_db__x3A__BI_audit_ENERGA_PRACOWNICY_adresy:BI_audit_ENERGA_PRACOWNICY_adresy"]);
						}

						listItemsPracownik += '<tr><td style="white-space:nowrap">' +
								'<input style="vertical-align:top" type="checkbox" name="prID[]" value="'+row['ID']+'" />' +
								'<i onClick="pracownicyLoadMoreRecordFunctions(event, this, '+row['ID']+')" style="margin-left:6px; cursor:pointer; color:#333" class="glyphicon glyphicon-menu-hamburger" title="Więcej funkcji dla rekordu nr ' + row['ID'] + '"></i>' +
							'</td>' +
							'<td align="right">'+row["ID"]+'</td>' +
							'<td align="right">' + ( row["imiona"] || '' ) + '</td>' +
							'<td align="right">' + ( row["nazwisko"] || '' ) + '</td>' +
							'<td align="right">' + ( row["nip"] || '' ) + '</td>' +
							'<td align="right">' + ( row["pesel"] || '' ) + '</td>' +
							'<td align="right">' + ( row["regon"] || '' ) + '</td>' +
							'<td align="right">' + ( row["source"] || '' ) + '</td>' +
							'<td align="right">' + ( row["jednostka_organizacyjna"] || '' ) + '</td>' +
							'<td align="right">' + ( row["A_STATUS"] || '' ) + '</td>' +
							'<td align="right">' + ( row["A_STATUS_INFO"] || '' ) + '</td>' +
							'<td align="right">' + ( row["L_APPOITMENT_USER"] || '' ) + '</td>' +
							'<td align="right">'+ addresPerson +'</td></tr>';
					});

			if (data.body.pagination.size) {
						Pagination.Init(document.getElementById('pagination-pracownicy'), {
							  url: BASE_URLS+'index.php?_route=UrlAction_Bocian#PRACOWNICY',
								id_pagination: 'pagination-pracownicy',
								type: 'PRACOWNICY',
								limit: data.body.pagination.limit,
								total_items: data.body.pagination.total_items, // pages size
								size: data.body.pagination.size, // pages size
								page: data.body.pagination.current,  // selected page
								step: 1   // pages before and after current
						});

						var paginationShowNextCount = 1;
						if ( parseInt(data.body.pagination.current) !== 1) {
							 paginationShowNextCount = parseInt(data.body.pagination.limit) * (parseInt(data.body.pagination.current) - 1 ) + 1;
						}
						$('#paginationShowNextCount-PRACOWNICY').text(paginationShowNextCount);
						$('#smad-filter-desc-pracownicy').text(data.body.pagination.total_items);
						if (data.body.pagination.total_items > 0) {
							var btnGraphView = $('<button class="btn btn-primary smad-pracownicy-graph-button" onClick="graphShowHide(\'pracownicy\')" style="padding:1px 5px; margin-left:12px">GRAF POWIĄZAŃ</button>')

							var btnAddAll = $('<button class="btn btn-primary" style="padding:1px 5px; margin-left:12px">DODAJ WSZYSTKIE DO ANALIZY</button>')
							btnAddAll.on('click', { pagination: data.body.pagination }, function (event) {
								// event.data.pagination: { [ filter_idGroup: ... ] }
								// fetch ids from request, set to LocatStorage, redirect to '#KONTRAHENCI'
								var postData = {}
								if ('filter_idGroup' in event.data.pagination && event.data.pagination['filter_idGroup']) postData['filter_idGroup'] = event.data.pagination['filter_idGroup']
								Object.keys(event.data.pagination).filter(function (key) {
									return ('f_' === key.substr(0, 2))
								}).forEach(function (filterKey) {
									var value = event.data.pagination[filterKey]
									postData[filterKey] = value
								})
								var thisButton = $(this)
								thisButton.attr('disabled', true)
								thisButton.text( thisButton.text() + '...' )
								p5UI__notifyAjaxCallback({ type: 'info', msg: "Pobieranie pracowników..." })
								global.fetch(URL_FETCH_PRACOWNICY_IDS_AJAX, {
									credentials: 'same-origin',
									method: 'POST',
									headers: {
										'Content-Type': 'application/json'
									},
									body: JSON.stringify(postData)
								})
								.then(function __parseJSON(response) {
									return response.json()
								})
								.then(function (json) {
									if ('success' === json.type && json.body && json.body.ids) {
										updateListIdBiAuditReaport('PRACOWNICY', json.body.ids.map(function (id) {
											return parseInt(id)
										}))
										thisButton.attr('disabled', false)
										var txt = thisButton.text()
										thisButton.text( '...' === txt.substr(-3) ? txt.substr(0, txt.length - 3) : txt )
										p5UI__notifyAjaxCallback({ type: 'success', msg: "Dodano "+json.body.ids.length+" pracowników" })
										window.location.hash = 'KONTRAHENCI'
									}
								})
								.catch(function (e) {
									p5UI__notifyAjaxCallback({ type: 'error', msg: '' + e })
									thisButton.attr('disabled', false)
									var txt = thisButton.text()
									thisButton.text( '...' === txt.substr(-3) ? txt.substr(0, txt.length - 3) : txt )
								})
							})
							$('#smad-filter-desc-pracownicy').append(btnAddAll);
							$('#smad-filter-desc-pracownicy').append(btnGraphView);

						}
			}


			// wyświetlenie wybranej grupy w naglówku nad tabela
			var groupSelectData = getNameGroupById(getItemLocalStorage('Bocian.biAuditForm.pracownicy.groups'), filterIdGroup);
			$('#smad-filter-head-title-pracownicy').text(groupSelectData);

			// zaladaowanie listy pracowników
			$( "#body-pracownicy" ).html( listItemsPracownik);
				checkAll('PRACOWNICY');
				catchEventCheckbox('PRACOWNICY');
				checkedChoiseItems('PRACOWNICY', getItemLocalStorage('Bocian.biAuditForm.pracownicyIds') );

				updateTopCounters();
			}).catch(function(error) {
				if(DBG) console.log('request failed', error)
			})

}

function selectPage(type, nrPage) {
	var type = type.toLowerCase();

	$('#pagination-' + type + ' ul li a').each(function(index, value){
		if (this.text === nrPage) {
			$(this).addClass('active');
		} else {
			$(this).removeClass('active');
		}
	});
}

function checkAll(type) {

	$('#checkAll-' + type).change(function() {

		  var valueCheckbox = null;
			var checkboxes = $('form').find(':checkbox');
			if($(this).prop('checked')) {
				checkboxes.prop('checked', true);
				//valueCheckbox = checkboxes.prop("checked");
					 var allValsChecked = [];
					 var checkedValues = $('#smad-table-' + type + ' input:checkbox:checked').map(function() {

						 if (this.value !== 'on') {
							  allValsChecked.push(parseInt(this.value));
						 }
					}).get();

					updateListIdBiAuditReaport(type, allValsChecked);

			} else {

				checkboxes.prop('checked', false);

				var allValsUnChecked = [];
				var checkedValues = $('#smad-table-' + type + ' input:checkbox:not(:checked)').map(function() {
					if (this.value !== 'on') {
						 allValsUnChecked.push(parseInt(this.value));
					}
			 }).get();

				deleteListIdBiAuditReaport(type, allValsUnChecked);
			}

			// update count selected IDs
			updateCountItemCheckedByType(type.toLowerCase());
	});
}

/**
 * Select again checkbox before selected item chekbox from storage (pracownicy/kontrahenci)
 */
function checkedChoiseItems(type, store) {

	updateCountItemCheckedByType(type.toLowerCase());

	var idElement = 'smad-table-' + type;

	// if id element exist
	if (document.getElementById(idElement)) {

		// if not checked
		if (!store) {
			return false;
		}

		// checked again if user selected Item (pracownicy/kontrahent)
			for (i = 0; i < store.length; i++) {
				$('#body-'+type.toLowerCase() +' input[type=checkbox] ').map(function(k, v) {
				    if ( store[i] === parseInt(this.value) ){
								$(this).prop('checked', true);
				    }
					}).get();
			}

	}

	$('#smad-table-' + type + ' input[type=checkbox]').on( 'load', function() {
		var itemsCHecked = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');

	  getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');

				if (itemsCHecked.lenght === 0 ) {
						return;
				}
			  var valueCheckbox = null;
				var checkboxes = $('form').find(':checkbox');
				if($(this).prop('checked')) {
					   checkboxes.prop('checked', true);
						 var allValsChecked = [];
						 var checkedValues = $('#smad-table-' + type + ' input:checkbox:checked').map(function() {

							 if (this.value !== 'on') {
								  allValsChecked.push(parseInt(this.value));
							 }
				}).get();

					updateListIdBiAuditReaport(type, allValsChecked);

			} else {

				checkboxes.prop('checked', false);

				var allValsUnChecked = [];
				var checkedValues = $('#smad-table-' + type + ' input:checkbox:not(:checked)').map(function() {
					if (this.value !== 'on') {
						 allValsUnChecked.push(parseInt(this.value));
					}
			 }).get();

				deleteListIdBiAuditReaport(type, allValsUnChecked);
			}

	});
}

function catchEventCheckbox(type) {

		$('#smad-table-' + type + ' input[type="checkbox"]').on('change', function() {
		    if($(this).is(":checked")) {
					var allValsChecked = [];
					if (this.value !== 'on') {
						 allValsChecked.push(parseInt(this.value));
					}

					updateListIdBiAuditReaport(type, allValsChecked);
		    } else  {

						var allValsUnChecke = [];
						if (this.value !== 'on') {
							 allValsUnChecke.push(parseInt(this.value));
						}

						deleteListIdBiAuditReaport(type, allValsUnChecke);
		    }

				// update count selected IDs
				updateCountItemCheckedByType(type.toLowerCase());
		});

}

function clearSelectedCheckbox() {
	$('#checkAll-PRACOWNICY').prop('checked', false)
	$('#checkAll-KONTRAHENCI').prop('checked', false)
}

function updateListIdBiAuditReaport(type, valueArray) {

		var currentStoragePracownicyIds = [];
		var updateListPracownicyIds = null;
		var currentStorageKontrahenciIds = [];
		var updateListKontrahenciIds = null;

		if ( type == 'PRACOWNICY') {
				currentStoragePracownicyIds = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');

				if(currentStoragePracownicyIds !== null) {
					updateListPracownicyIds = [...new Set([...currentStoragePracownicyIds ,...valueArray])];
				}
				else {
					updateListPracownicyIds = valueArray;
				}

				setItemLocalStorage('Bocian.biAuditForm.pracownicyIds', updateListPracownicyIds);
		}

		if ( type == 'KONTRAHENCI') {
				currentStorageKontrahenciIds = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');

				if(currentStorageKontrahenciIds !== null) {
					updateListKontrahenciIds = [...new Set([...currentStorageKontrahenciIds ,...valueArray])];
				}
				else {
					updateListKontrahenciIds = valueArray;
				}

				setItemLocalStorage('Bocian.biAuditForm.kontrahenciIds', updateListKontrahenciIds);
		}
}

function deleteListIdBiAuditReaport(type, valueArray) {

		var currentStoragePracownicyIds = [];
		var updateListPracownicyIds = null;

		if ( type == 'PRACOWNICY') {
				deleteItemLocalStorage('Bocian.biAuditForm.pracownicyIds', valueArray);
		}

		if ( type == 'KONTRAHENCI') {
				deleteItemLocalStorage('Bocian.biAuditForm.kontrahenciIds', valueArray);
		}
}

// filter group detect
function fetchGroupPracownicy() {
		fetch(URL_FETCH_GROUP_PRACOWNICY, {
				credentials: 'same-origin'
			})
			.then(function parseJSON(response) {
				return response.json()
			})
			.then(function(data) {
					setItemLocalStorage('Bocian.biAuditForm.pracownicy.groups', data.body.itmesGroupPracownicy);

					if (data.body.itmesGroupPracownicy === null) {
						return;
					}

					var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup');
					var currentDepthValue = getItemLocalStorage('Bocian.biAuditForm.depth');
					setItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup', filterIdGroup);

					setItemLocalStorage('Bocian.biAuditForm.depth', currentDepthValue);

					var groupsPracownicy = '';
					var activeButton = '';

					data.body.itmesGroupPracownicy.forEach (function(row) {
							activeButton = '';
							if ( filterIdGroup === parseInt(row['ID']) ) {activeButton = 'active'; $('#group-pracownicy button.active').removeClass('active');
							}
							groupsPracownicy += '<button class="btn btn-default '+activeButton+'" title="' + row['NAZWA'] + '" data-group-filter="' + row['ID'] + '">' + row['NAZWA'] + '</button>';
					});

					$("#group-pracownicy").append(groupsPracownicy);
					updateCountItemCheckedByType('pracownicy');

					// detect filter group
					detectChoiseFilter();
			}).catch(function(error) {
				if(DBG) console.log('request failed', error)
			});
}

function fetchGroupKontrahenci() {

		fetch(URL_FETCH_GROUP_KONTRAHENCI, {
				credentials: 'same-origin'
			})
			.then(function parseJSON(response) {
				return response.json()
			})
			.then(function(data) {
					setItemLocalStorage('Bocian.biAuditForm.kontrahenci.groups', data.body.itemsGroupKontrahenci);

					if (data.body.itemsGroupKontrahenci === null) {
						return;
					}

					var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup');
					var currentDepthValue = getItemLocalStorage('Bocian.biAuditForm.depth');
					setItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup', filterIdGroup);

					setItemLocalStorage('Bocian.biAuditForm.depth', currentDepthValue);

					var groupsKontrahenci = '';
					var activeButton = '';

					data.body.itemsGroupKontrahenci.forEach (function(row) {
							activeButton = '';
							if ( filterIdGroup === parseInt(row['ID']) ) { activeButton = 'active'; $('#group-kontrahenci button.active').removeClass('active'); }
							groupsKontrahenci += '<button class="btn btn-default '+activeButton+'" title="'+row['NAZWA']+'" data-group-filter="'+row['ID']+'">'+row['NAZWA']+'</button>';
					});

					$("#group-kontrahenci").append(groupsKontrahenci);
					updateCountItemCheckedByType('kontrahenci');

					// detect filter group
					detectChoiseFilter();
				if(DBG) console.log('request succeeded with JSON fetchGroupKontrahenci', data.body.itemsGroupKontrahenci);
			}).catch(function(error) {
				if(DBG) console.log('request failed', error)
			});
}


function detectChoiseFilter() {

	$('#group-kontrahenci').on('click', 'button', function(evt) {
		$('#group-kontrahenci button.active').removeClass('active');
		$(this).addClass('active');

		// pobranie id grupy kliknietego buttonu
		var filterIdGroup = $(this).attr("data-group-filter");
		// aktaulna wartość  zagłebienia
		var currentDepthValue = getItemLocalStorage('Bocian.biAuditForm.depth');
		// czy zwracać wyniki tylko z obiektami docelowymi
		var analizaOnlyTargets = getItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets');

		//reset LocalStorage
		// defaultBIAuditLocalStorage();
		// ustawienie ostaniej wartości zagłebienia  przed resete
		setItemLocalStorage('Bocian.biAuditForm.depth', currentDepthValue);

		// czy zwracać wyniki tylko z obiektami docelowymi
		setItemLocalStorage('Bocian.biAuditForm.analizaOnlyTargets', analizaOnlyTargets);

		// ustawić id grupy do sesyjnej
		setItemLocalStorage('Bocian.biAuditForm.kontrahenci.filterIdGroup', parseInt(filterIdGroup));
		// wywylac funckje pobrania danych
		urlFetchKontrahenci(1);

	});
	$('#group-pracownicy').on('click', 'button', function(e) {
		e.preventDefault();
		$('#group-pracownicy button.active').removeClass('active');
		$(this).addClass('active');

		// pobranie id grupy kliknietego buttonu
		var filterIdGroup = $(this).attr("data-group-filter");
		// aktaulna wartość  zagłebienia
		var currentDepthValue = getItemLocalStorage('Bocian.biAuditForm.depth');
		//reset LocalStorage
		// defaultBIAuditLocalStorage();
		// ustawienie ostaniej wartości zagłebienia  przed resete
		setItemLocalStorage('Bocian.biAuditForm.depth', currentDepthValue);

		// ustawić id grupy do sesyjnej
		setItemLocalStorage('Bocian.biAuditForm.pracownicy.filterIdGroup', parseInt(filterIdGroup));
		// wywylac funckje pobrania danych
		urlFetchPracownicy(1);

	});

}


// Local storage
function setItemLocalStorage(key, array) {
	localStorage.setItem(key, JSON.stringify(array));
}

function getItemLocalStorage(key) {
	var retrievedData = localStorage.getItem(key);
	var response = JSON.parse(retrievedData);

	return response;
}

function deleteItemLocalStorage(key, itemsArray) {

	var currentStorageArray = getItemLocalStorage(key);

	var newStorageArray = removeItemArrayInArray(currentStorageArray, itemsArray);

	setItemLocalStorage(key, newStorageArray);
}

/**
 * arr - array
 * item - search item
 */
function removeItemInArray(arr, item) {
      for(var i = arr.length; i--;) {
          if(arr[i] === item) {
              arr.splice(i, 1);
          }
      }

			return arr;
  }

/**
 * arr - array
 * item - array list items
 */
function removeItemArrayInArray(arr, itemsArray) {

      for(var i = arr.length; i--;) {
	      for(var j = itemsArray.length; j--;) {
	          if(arr[i] === itemsArray[j]) {
	              arr.splice(i, 1);
	          }
	      }
      }

			return arr;
  }


/**
 * Function show/hide graph view
 */
function graphShowHide(nameSection) {
	var node = $('.smad-'+nameSection+'-graph-view')
	if (!node || !node.length) return;
	if ('block' !== node.css('display')) {
		node.show()
		graphFetchData(node.get(0), nameSection)
	} else {
		node.hide()
	}
}
function graphFetchData(node, nameSection) {
	var page = page || getItemLocalStorage('Bocian.biAuditForm.'+nameSection+'.pagination.page');
	if ( page === 1) {
		setItemLocalStorage('Bocian.biAuditForm.'+nameSection+'.pagination.page', 1);
	}

	var filterIdGroup = getItemLocalStorage('Bocian.biAuditForm.'+nameSection+'.filterIdGroup');

	var frm = document.getElementById('filtersFieldRemoveBtn-' + nameSection.toUpperCase()).form
	var fieldNameList = ('pracownicy' === nameSection) ? FIELD_LIST_PRACOWNICY : FIELD_LIST_KONTRAHENCI
	var filterFields = fieldNameList.filter(function (fieldName) {
		if (!frm[fieldName] && DBG) console.log('Err missing field: "'+fieldName+'"')
		return (frm[fieldName]) ? true : false
	}).map(function (fieldName) {
		return [ fieldName, frm[fieldName].value ]
	}).filter(function (filter) {
		return ( filter[1].length > 0 )
	})
	// filterFields = (filterFields.length > 0) ? '&' + filterFields : ''

	// <ogc:Filter>
	//     <ogc:Or>
	//       <ogc:PropertyIsLike wildCard="*" singleChar="%23" escapeChar="!">
	//         <ogc:PropertyName>A_STATUS</ogc:PropertyName>
	//         <ogc:Literal>*O%23MA*</ogc:Literal>
	//       </ogc:PropertyIsLike>
	//       <ogc:PropertyIsLike wildCard="*" singleChar="%23" escapeChar="!">
	//         <ogc:PropertyName>A_STATUS</ogc:PropertyName>
	//         <ogc:Literal>*ARNING</ogc:Literal>
	//       </ogc:PropertyIsLike>
	//     </ogc:Or>
	//   </ogc:Filter>
	var ogcFilterFields = (filterFields.length > 0)
	? '<ogc:Filter><ogc:And>' + filterFields.map(function(filter) {
		if ('ID' === filter[0].substr(2)) return '<ogc:PropertyIsEqualTo>' +
			'<ogc:PropertyName>' + filter[0].substr(2) + '</ogc:PropertyName>' +
			'<ogc:Literal>' + filter[1] + '</ogc:Literal>' +
		'</ogc:PropertyIsEqualTo>';

		return '<ogc:PropertyIsLike wildCard="*" singleChar="%23" escapeChar="!">' +
			'<ogc:PropertyName>' + filter[0].substr(2) + '</ogc:PropertyName>' +
			'<ogc:Literal>*' + filter[1] + '*</ogc:Literal>' +
		'</ogc:PropertyIsLike>';
	}) + '</ogc:And></ogc:Filter>'
	: ''

	var paginationLimit = 20;

	if(DBG)console.log('graphFetchData...', {
		paginationLimit: paginationLimit,
		page: page,
		filterIdGroup: filterIdGroup,
		filterFields: filterFields,
		ogcFilterFields: ogcFilterFields,
	});

	function refFieldsOnPathToList(typeName, fields) {
		var fields = fields || []
		var flatList = []
		var refPathBase = [
			'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
			'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row',
			'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object'
		]
		flatList.push(refPathBase.concat(typeName).join('/'))
		fields.forEach(function (fieldName) {
			flatList.push(refPathBase.concat(typeName, fieldName).join('/'))
		})
		return flatList;
	}

	p5WFS_GetFeature('default_db__x3A__BI_audit_ENERGA_PRACOWNICY:BI_audit_ENERGA_PRACOWNICY',
		Object.assign({
			sortBy: 'ID+D',
			maxFeatures: paginationLimit,
			startIndex: (page - 1) * paginationLimit,
			// TODO: backRefNS, backRefPK, backRefField - TODO: from groups
			// resolve: 'all',
			// resolveDepth: 2
			'ogc:Filter': '<wfs:Query>' + '\n' + [
				'ID',
				'imiona',
				'nazwisko',
				'miejscowosc'
			].concat(refFieldsOnPathToList('default_db__x3A__BI_audit_KRS:BI_audit_KRS', [ 'ID', 'nazwa', 'krs', 'S_miejscowosc' ]))
			.concat(refFieldsOnPathToList('default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI:BI_audit_ENERGA_RUM_KONTRAHENCI', [ 'ID', 'Pelna_nazwa_kontrahenta' ]))
			.concat(refFieldsOnPathToList('default_db__x3A__BI_audit_MSIG:BI_audit_MSIG', [ 'ID', 'nazwa' ]))
			.concat(refFieldsOnPathToList('default_db__x3A__BI_audit_CEIDG:BI_audit_CEIDG', [ 'ID', 'nazwisko', 'firma' ]))
			.concat([
				// '*',
				// 'default_db__x3A__BI_audit_ENERGA_PRACOWNICY_adresy:BI_audit_ENERGA_PRACOWNICY_adresy/*',
				[
					'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
					'ID'
				].join('/'),
				[
					'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
					'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row',
					'ID'
				].join('/'),
				[
					'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
					'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row',
					'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
					'ID'
				].join('/')
			]).map(function (fieldName) {
				return '<wfs:PropertyName>' + fieldName + '</wfs:PropertyName>';
			}).join('\n') + '\n' +
			( ogcFilterFields ? ogcFilterFields : '' ) +
			'</wfs:Query>'
		}, (filterIdGroup > 0)
			? {
					backRefNS: 'default_db/BI_audit_ENERGA_PRACOWNICY_group/BI_audit_ENERGA_PRACOWNICY_group',
					backRefPK: filterIdGroup,
					backRefField: 'default_db__x3A__BI_audit_ENERGA_PRACOWNICY:BI_audit_ENERGA_PRACOWNICY',
				}
			: {}
		)
	).then(function (items) {
		if(DBG)console.log('p5WFS_GetFeature: items: ', items);
		graphRender(node, {
			msg: "Pobrano dane",
			typeName: ('pracownicy' === nameSection) ? 'default_db__x3A__BI_audit_ENERGA_PRACOWNICY:BI_audit_ENERGA_PRACOWNICY' : 'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI:BI_audit_ENERGA_RUM_KONTRAHENCI',
			items: items
		})
	}).catch(function (err) {
		if(DBG)console.log('p5WFS_GetFeature: err: ', err);
		// graphRender(node, { msg: "Wystąpiły błędy podczas pobierania danych", nameSection: nameSection, err: err })
	})
}

function graphRender(wrapNode, props) {
	var svgNode = jQuery(wrapNode).children('svg')
	svgNode = (svgNode.length) ? d3.select(svgNode.get(0)) : d3.select(wrapNode).append("svg")
	// svg.append("rect").attr("x",0).attr("y",0).attr("width","100%").attr("height","100%").attr("fill","white").attr('class','background').on('mouseup', () => redraw())
	// svgNode.attr("width", '100%')
	// 	.attr("height", '300px')
		// .append("g").attr("transform", "translate(" + margin.left + "," + margin.top + ")");

	// var data = parseGraphRec(props.items, props.nameSection)
	var _todoGraphData = [];
	parseResponseRec(_todoGraphData, props.items, props.typeName)
	if(DBG)console.log('_todoGraphData', _todoGraphData)
	var _nodes = [];
	var _links = [];
	var mapNodeIdToIdx = {};
	_todoGraphData.forEach(function (levelData, levelIdx) {
		if (levelData.nodes && levelData.nodes.length) {
			levelData.nodes.forEach(function (node) {
				try {
					if (node.id in mapNodeIdToIdx) return;
					_nodes.push(node) // _nodes.add(node)
					mapNodeIdToIdx[node.id] = _nodes.length - 1
				} catch (e) {
					if(DBG)console.log('_graphData.nodes.add [level='+levelIdx+'] error:', e);
				}
			})
		}
	})

	var linkIdsAdded = []
	_todoGraphData.forEach(function (levelData, levelIdx) {
		if (levelData.edges && levelData.edges.length) {
			levelData.edges.forEach(function (edge) {
				if(DBG)console.log('_graphData.edges.add [level='+levelIdx+']:', {edge, source:mapNodeIdToIdx[edge.source], target:mapNodeIdToIdx[edge.target], mapNodeIdToIdx});
				// try {
					// var source = mapNodeIdToIdx[edge.source]
					// var target = mapNodeIdToIdx[edge.target]
					// if (!source || !target) { // && !== 0
					// 	console.warn('(!source || !target)', {source, target, edge, mapNodeIdToIdx})
					// }
					if (-1 !== linkIdsAdded.indexOf(edge.id)) return
					// _links.push({
					// 	id: edge.id,
					// 	source: mapNodeIdToIdx[edge.source],
					// 	target: mapNodeIdToIdx[edge.target],
					// 	value: 1
					// })
					_links.push({
						id: edge.id,
						source: edge.source,
						target: edge.target,
						value: 1
					}) // _edges.add(edge)
					linkIdsAdded.push(edge.id)
				// } catch (e) {
				// 	if(DBG)console.log('_graphData.edges.add [level='+levelIdx+'] error:', e);
				// }
			})
		}
	})

	var totalLinks = _links.length
	// console.log('DBG:0: _links', _links)
	// console.log('DBG:1: _nodes', _nodes)
	_nodes = _nodes.filter(function (node, idx) {
		if (node.typeName !== props.typeName) return true
		for (i=0; i<totalLinks; i++) {
			var link = _links[i]
			if (_links[i].source === node.id) return true
			if (_links[i].target === node.id) return true
		}
		return false
	})
	// console.log('DBG:2: _nodes', _nodes)
	jQuery(wrapNode).find('p').remove()
	if (!_nodes || !_nodes.length) {
		jQuery(wrapNode).find('svg').remove()
		jQuery(wrapNode).append('<p>Brak powiązań</p>')
		return;
	}

	var graphData = { nodes: _nodes, links: _links };

	var graf = renderGraph(svgNode, graphData, {
		width: jQuery(wrapNode).width()
	})
	graf.on('click', (event) => {
	  if(DBG)console.log('event', event)
	  // event = {
	  //   nativeEvent: d3.event,
	  //   node: a,
	  //   element: d3.event.srcElement
	  // }

	  // TODO: !a.expanded && redraw({type: a.name, criteria: 'ID'})
	})
}

function parseGraphRec(items, featureType, parentFeatureId) {
	var parentFeatureId = parentFeatureId || null
	var nodesArray = []
	var linksArray = []
	if (!items) return;
	items.forEach(function (item) {
		if ('string' === typeof item) {
			if(DBG)console.log('TODO: xlink "'+item+'": ', {item:item, parentFeatureId:parentFeatureId})
			return;
		}
		if (!item['ID']) {
			if(DBG)console.log('TODO: SKIP item('+featureType+') - missing ID: ', {item:item, parentFeatureId:parentFeatureId})
			return;
		}
		var id = item['ID']
		console.log('item('+featureType+'): ', {item:item, parentFeatureId:parentFeatureId})
		var featureId = featureType + '.' + id
		Object.keys(item).filter(function (fieldName) { return ('ID' !== fieldName); })
		.forEach(function (fieldName) {
			parseGraphRec(item[fieldName], fieldName, featureId)
		})
	})
  // items.forEach(element => {
  //   const rowObject = hasTargetArray(element);
  //   if (rowObject)
  //     rowObject.array.forEach(objectElement => {
  //       const trackNode = hasTargetArray(objectElement);
  //       if (trackNode) {
  //         let group = trackNode.name;
  //         let expanded = false;
  //         if (expansion && expansion.type && group === expansion.type) {
  //           group = trackNode.array[0][expansion.criteria];
  //           expanded = true;
  //         }
  //         nodes[group] = {expanded: expanded, type: trackNode.name};
  //         instanceTypes[trackNode.array[0].ID] = group;
  //       }
  //     });
  // });

	return {
		nodes: nodesArray,
		links: linksArray
	}
}

function parseResponseRec(_todoGraphData, json, typeName, parentNodeId, level) {
	var level = level || 0
	var parentNodeId = parentNodeId || null
	if(DBG)console.log('DBG::parseResponseRec', {json:json, typeName:typeName, parentNodeId:parentNodeId, isString: p5Utils__isString(json), isArray: p5Utils__isArray(json), isObject: p5Utils__isObject(json)});
	if (p5Utils__isArray(json)) {
		// TODO: create named group
		var isXlinkList = (json.length > 0 && p5Utils__isString(json[0]))
		json.forEach(function (subJson) {
			if (isXlinkList) {
				parseResponseXlinkListRec(_todoGraphData, subJson, typeName, parentNodeId, level)
			} else {
				parseResponseRec(_todoGraphData, subJson, typeName, parentNodeId, level)
			}
		})
	} else if (p5Utils__isObject(json) && isP5LinkObject(json)) {
		if(DBG)console.log('DBG::parseResponseRec isP5LinkObject');
		parseResponseP5Link(_todoGraphData, json, typeName, parentNodeId, level)
	} else if (p5Utils__isObject(json)) {
		// _todoGraphData.nodes.add({ id: nodeId, label: nodeId })
		if (!_todoGraphData[level]) _todoGraphData[level] = { nodes: [], edges: [] }
		var nodeObject = dataMakeNode({
			typeName: typeName,
			primaryKey: (json['ID']) ? json['ID'] : null, // TODO: get primaryKey from object
			row: json,
		})
		var nodeId = nodeObject.id

		if ("default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row" === typeName) {
			parseResponseRec__row(_todoGraphData, json, typeName, parentNodeId, level)
		}
		else if ("default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object" === typeName) {
			// parseResponseRec__row_object(_todoGraphData, json, typeName, parentNodeId, level)
			Object.keys(json).filter(function (fieldName) {
				return (fieldName.indexOf(':') > -1)
			})
			.forEach(function (fieldName) {
				var value = json[fieldName]
				parseResponseRec(_todoGraphData, value, fieldName, parentNodeId, level + 1)
			})
		}
		else {
			_todoGraphData[level].nodes.push(nodeObject)
			if (parentNodeId) {
				_todoGraphData[level].edges.push(dataMakeEdge(parentNodeId, nodeObject))
			}
			Object.keys(json).filter(function (fieldName) {
				return (fieldName.indexOf(':') > -1)
			})
			.forEach(function (fieldName) {
				var value = json[fieldName]
				parseResponseRec(_todoGraphData, value, fieldName, nodeId, level + 1)
			})
		}
	} else if (p5Utils__isString(json)) {
		if(DBG)console.log('TODO: Not implemented - parseResponseRec isString');
	} else {
		if(DBG)console.log('TODO: Not implemented - parseResponseRec is not string, not array and not object');
	}
}
function parseResponseXlinkListRec(_todoGraphData, json, typeName, parentNodeId, level) {
	if(DBG)console.log('DBG::parseResponseRec:XlinkList', {json:json, typeName:typeName, parentNodeId:parentNodeId, isString: p5Utils__isString(json), isArray: p5Utils__isArray(json), isObject: p5Utils__isObject(json)});
	if (p5Utils__isString(json)) { // xlink "https://biuro.biall-net.pl/wfs/default_db/BI_audit_ENERGA_RUM_KONTRAHENCI#BI_audit_ENERGA_RUM_KONTRAHENCI.9233",
		var nodeId = json.substr(json.indexOf('#') + 1)
		{
			// _graphData.nodes.add({ id: nodeId, label: nodeId })
			if (!_todoGraphData[level]) _todoGraphData[level] = { nodes: [], edges: [] }
			var nodeObject = dataMakeXlinkNode({
				xlink: json,
				typeName: typeName,
			})
			_todoGraphData[level].nodes.push(nodeObject)
			if (parentNodeId) {
				_todoGraphData[level].edges.push(dataMakeEdge(parentNodeId, nodeObject))
			}
		}
	} else if (p5Utils__isObject(json) && isP5LinkObject(json)) {
		parseResponseP5Link(_todoGraphData, json, typeName, parentNodeId, level)
	} else {
		if(DBG)console.log('TODO: Not implemented - parseResponseRec:XlinkList is not string and not object');
	}
}
function parseResponseP5Link(_todoGraphData, json, typeName, parentNodeId, level) {
	if(DBG)console.log('parseResponseRec isObject and P5Link - fetch more xlink object');
	// example json: { type: "next",
	//  @backRefNS: "default_db/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA/BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA",
	//  @backRefPK: "42",
	//  @typeName: "default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_P…ow:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row",
	//  @startIndex: "10" }
	if (!parentNodeId) throw "Missing parentNodeId for ref link object";
	var objectName = typeName.substr(typeName.indexOf(':') + 1)
	{
		// _graphData.nodes.add({ id: nodeId, label: nodeId })
		if (!_todoGraphData[level]) _todoGraphData[level] = { nodes: [], edges: [] }
		switch (json.type) {
			case 'next': {
        // TODO: add fetch next node
				// var nodeObject = dataMakeFetchMoreNode({
				// 	parentNodeId: parentNodeId,
				// 	type: json.type,
				// 	objectName: objectName,
				// 	ref: json,
				// })
				// _todoGraphData[level].nodes.push(nodeObject)
				// _todoGraphData[level].edges.push(dataMakeFetchMoreEdge(parentNodeId, nodeObject))
			} break;
			default: {
				if(DBG)console.log('TODO: Not implemented - parseResponseRec isObject with type "'+json.type+'" - fetch more xlink object');
			}
		}
	}
}

function parseResponseRec__row(_todoGraphData, json, typeName, parentNodeId, level) {
	var nodeObject = dataMakeNode({
		typeName: typeName,
		primaryKey: (json['ID']) ? json['ID'] : null, // TODO: get primaryKey from object
	})
	var nodeId = nodeObject.id

	// 'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row',
	// 'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object',
	// 'default_db__x3A__BI_audit_KRS:BI_audit_KRS' --> Kontrahenci
	var rowObjectChildrens = []
	var rowTN = 'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row'
	var rowObjTN = 'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object'
	// { row: row_obj: [ { ID, kontr: [ "http...kontr.ID" ] }, { ID, kontr: [ "http...krs.ID" ] } ], ... }
	var rowJson = json
	if (rowJson[rowObjTN] && rowJson[rowObjTN].length > 1) {
		var pathItems = []
		rowJson[rowObjTN].forEach(function (rowObjJson) {
			Object.keys(rowObjJson)
				.filter(function (rowObjFld) { return (-1 !== rowObjFld.indexOf(':')); })
				.filter(function (rowObjRefFld) { return (rowObjJson[rowObjRefFld] && rowObjJson[rowObjRefFld].length); })
				.forEach(function (rowObjRefFld) {
					pathItems.push([ rowObjRefFld, rowObjJson[rowObjRefFld][0] ])
				})
		})
	}
	// console.log('node('+nodeId+') pathItems:', pathItems);
	var lastParentFid = null
	pathItems.reverse().forEach(function (pathItem) {
		var nodeObject = ('string' === typeof pathItem[1])
		? dataMakeXlinkNode({
				xlink: pathItem[1],
				typeName: pathItem[0]
			})
		:	 dataMakeNode({
				typeName: pathItem[0],
				primaryKey: (pathItem[1]['ID']) ? pathItem[1]['ID'] : null,
				row: pathItem[1]
			})
		;
		// _todoGraphData[todoLevel].nodes.push(nodeObject) // already added below
		if (lastParentFid) _todoGraphData[level].edges.push(dataMakeEdge(lastParentFid, nodeObject))
		lastParentFid = nodeObject.id
	})

	Object.keys(json).filter(function (fieldName) {
		return (fieldName.indexOf(':') > -1)
	})
	.forEach(function (fieldName) {
		var value = json[fieldName]
		parseResponseRec(_todoGraphData, value, fieldName, parentNodeId, level + 1)
	})
}

function isP5LinkObject(json) {
	if ( !('type' in json) || !json['type'] ) return false;
	if ( !('value' in json) || !json['value'] ) return false;
	if ( !('@typeName' in json) || !json['@typeName'] ) return false;
	if ( !('@startIndex' in json) || !json['@startIndex'] ) return false;
	if ( !('@backRefPK' in json) || !json['@backRefPK'] ) return false;
	if ( !('@backRefNS' in json) || !json['@backRefNS'] ) return false;
	return true;
}

function dataMakeNode(params) {
	var objectName = params.typeName.substr(params.typeName.indexOf(':') + 1)
	var nodeId = objectName + '.' + params.primaryKey // TODO: primaryKey?
	var graphNode = {
		id: nodeId,
		name: nodeId,
		group: objectName,
		_loaded: true,
		typeName: params.typeName,
		primaryKey: params.primaryKey // TODO: _primaryKey
	}
	if (params.row) graphNode.row = params.row
	return graphAddNodeLabel(graphNode)
}
function dataMakeEdge(parentNodeId, nodeObject) {
	return {
		id: parentNodeId + nodeObject.id,
		source: parentNodeId,
		target: nodeObject.id,
	}
}
function dataMakeXlinkNode(params) {
	var objectName = params.typeName.substr(params.typeName.indexOf(':') + 1)
	var nodeId = params.xlink.substr(params.xlink.indexOf('#') + 1)
	var primaryKey = nodeId.substr(nodeId.lastIndexOf('.') + 1)
	var graphNode = {
		id: nodeId,
		name: nodeId,
		group: objectName,
		_loaded: false,
		typeName: params.typeName,
		primaryKey: primaryKey
	}
	return graphAddNodeLabel(graphNode)
}

function dataMakeFetchMoreNode(params) {
	// params = {
	// 	parentNodeId: parentNodeId,
	// 	type: json.type,
	// 	objectName: objectName,
	// 	ref: json,
	// }
	if(DBG)console.log('DBG dataMakeFetchMoreNode(params)', params)
	var nodeId = params.parentNodeId+'fetch-more-features-'+params.type+'-on-' + params.objectName;
	return {
		id: nodeId,
		label: 'Pobierz więcej (+)',
		group: 'fetch-more-data', // params.objectName,
		_loaded: false,
		_type: 'ref',
		parentNodeId: params.parentNodeId,
		ref: params.ref,
		// typeName: typeName,
		// primaryKey: nodeId.substr(nodeId.lastIndexOf('.') + 1)
	};
}
function dataMakeFetchMoreEdge(parentNodeId, fetchMoreNode) {
	// @param parentNodeId - from node id
	// @param fetchMoreNode - from dataMakeFetchMoreNode
	if(DBG)console.log('DBG dataMakeFetchMoreEdge(parentNodeId, fetchMoreNode)', {parentNodeId:parentNodeId, fetchMoreNode:fetchMoreNode})
	return {
		id: fetchMoreNode.id,
		from: parentNodeId,
		to: fetchMoreNode.id
	}
}
function makeShortLabel(label) { // TODO: shorter name
	// BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA_row_object.1234567

	if (label.length < 30) return label;
	var exLabel = label.split('.')
	if (exLabel.length !== 2) return label;
	return exLabel[0].substr(0, 24) + '...' + exLabel[0].substr(-10) + '.' + exLabel[1];
}
function graphAddNodeLabel(graphNode) {
	// var graphNode = {
	// 	id: nodeId,
	// 	name: nodeId,
	// 	group: objectName,
	// 	_loaded: true,
	// 	typeName: params.typeName,
	// 	primaryKey: params.primaryKey // TODO: _primaryKey
	// }
	var label = graphNode.id // TODO: get from schema assert @label attribute
	label = makeShortLabel(graphNode.id)
	switch (graphNode.typeName) {
		case 'default_db__x3A__BI_audit_KRS:BI_audit_KRS': {
			// <xs:assert test="@default_db__x3A__BI_audit_KRS:label = concat(nazwa, ' ', krs, ' ', S_miejscowosc)" id="I_audit_KRS___d6e76977-1">
			if (graphNode.row) label = [graphNode.row.nazwa, graphNode.row.krs, graphNode.row.S_miejscowosc].filter(function (val) { return val; }).join(' ');
			label = (label) ? label : makeShortLabel(graphNode.id)
			label = label + ' (krs)'
		} break;
		case 'default_db__x3A__BI_audit_ENERGA_PRACOWNICY:BI_audit_ENERGA_PRACOWNICY': {
			// <xs:assert id="_PRACOWNICY___d6e76324-1" test="@label = concat(imiona, ' ', nazwisko, ' ', miejscowosc)"/>
			if (graphNode.row) label = [graphNode.row.imiona, graphNode.row.nazwisko, graphNode.row.miejscowosc].filter(function (val) { return val; }).join(' ');
			label = (label) ? label : makeShortLabel(graphNode.id)
			label = label + ' (pracownicy)'
		} break;
		case 'default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI:BI_audit_ENERGA_RUM_KONTRAHENCI': {
			// <xs:assert id="KONTRAHENCI___d6e76526-1" test="@label = concat(substr(Pelna_nazwa_kontrahenta, 0, 20, '\n umów na kwotę ', @sum))"/>
			if (graphNode.row) label = [graphNode.row.Pelna_nazwa_kontrahenta].filter(function (val) { return val; }).join(' ');
			label = (label) ? label : makeShortLabel(graphNode.id)
			label = label + ' (kontrahent)'
		} break;
		case 'default_db__x3A__BI_audit_CEIDG:BI_audit_CEIDG': {
			// <xs:assert test="@label = concat(nazwisko, substring(firma, 1, 20))"/>
			if (graphNode.row) label = [graphNode.row.nazwisko, graphNode.row.firma].filter(function (val) { return val; }).join(' ');
			label = (label) ? label : makeShortLabel(graphNode.id)
			label = label + ' (ceidg)'
		} break;
		case 'default_db__x3A__BI_audit_MSIG:BI_audit_MSIG': {
			// <xs:assert test="@label = substring(nazwa, 1, 20)"/>
			if (graphNode.row) label = [graphNode.row.nazwa].filter(function (val) { return val; }).join(' ');
			label = (label) ? label : makeShortLabel(graphNode.id)
			label = label + ' (msig)'
		} break;
	}
	return Object.assign(graphNode, {
		label: label,
	})
}



/**
 * Cleart list local storage by type
 * typeNameLocalStorage - name (praconwicy/kontrahenci)
 */
function clearListLocalStorageByType(typeNameLocalStorage) {

	if (typeNameLocalStorage === 'pracownicy') {
		setItemLocalStorage('Bocian.biAuditForm.pracownicyIds', []);
	}

	if (typeNameLocalStorage === 'kontrahenci') {
		setItemLocalStorage('Bocian.biAuditForm.kontrahenciIds', []);
	}
	// update count selected item
	updateCountItemCheckedByType(typeNameLocalStorage);
	// unchecked checkbox
	$('#smad-table-'+typeNameLocalStorage.toUpperCase()+' form').find(':checkbox').prop('checked', false);
}

/**
 * Update count selected pracowniyc/kontrahenci
 */
function updateCountItemCheckedByType(typeNameLocalStorage) {
  var countId = 0;

	updateTopCounters();

	if (typeNameLocalStorage === 'pracownicy') {
		var countPracownicy = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');

		if (countPracownicy === null || countPracownicy === undefined) {
			return countId;
		}
		countId = Object.keys(countPracownicy).length;
		$('#count-selected-item-pracownicy').text(countId);
	}

	if (typeNameLocalStorage === 'kontrahenci') {
		var countKontrahenci = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');

		if (countKontrahenci === null || countKontrahenci === undefined) {
			return countId;
		}

		countId = Object.keys(countKontrahenci).length;
		$('#count-selected-item-kontrahenci').text(countId);
	}

	return countId;
}

function updateTopCounters() {
	var countPracownicy = getItemLocalStorage('Bocian.biAuditForm.pracownicyIds');
	var countKontrahenci = getItemLocalStorage('Bocian.biAuditForm.kontrahenciIds');
	var totalPracownicy = (countPracownicy) ? Object.keys(countPracownicy).length : 0;
	var totalKontrahenci = (countKontrahenci) ? Object.keys(countKontrahenci).length : 0;
	var depthValue = getItemLocalStorage('Bocian.biAuditForm.depth');
	if(DBG) console.warn({totalPracownicy: totalPracownicy, totalKontrahenci: totalKontrahenci})
	$('.top--count-selected-item-pracownicy').text(totalPracownicy ? '('+totalPracownicy+')' : '');
	$('.top--count-selected-item-kontrahenci').text(totalKontrahenci ? '('+totalKontrahenci+')' : '');
	$('.bottom--count-selected-item-pracownicy').text(totalPracownicy ? "Wybrano: (" + totalPracownicy + ") osób" : '');
	$('.bottom--count-selected-item-kontrahenci').text(totalKontrahenci ? "Wybrano: (" + totalKontrahenci + ") podmiotów/kontrahentaów" : '');


// disable button generate reaport if not choise 'praconwicy' or 'kontrahenci'
	if ( totalPracownicy === 0 && totalKontrahenci === 0 ) {
		$('.smad-generate-reaport-button').addClass('disabled');
	} else {

		if ( ( totalPracownicy === 0 || totalKontrahenci === 0 ) && parseInt(depthValue) > 6) {
			$('.bottom--message-warning-critical-search').text(messageCriticalSearchData);
			if(DBG) console.log('dodanie komunikatu niżej');
		} else {
			if(DBG) console.log('wyczyc komunikatu niżej');
			$('.bottom--message-warning-critical-search').text('');
		}

		$('.smad-generate-reaport-button').removeClass('disabled');
	}
}


// Pagination
var Pagination = {

    code: '',			// end show html paginations
    clickPage: 1, // set default 1 page

    // --------------------
    // Utility
    // --------------------
    //  initialize  default data
    Extend: function(data) {
        data = data || {};
        Pagination.url = data.url;
        Pagination.id_pagination = data.id_pagination;
        Pagination.type = data.type;
        Pagination.limit = data.limit;
        Pagination.total_items = data.total_items;
        Pagination.size = data.size || 2;
        Pagination.page = data.page || 1;
        Pagination.step = data.step || 3;
    },

    // add pages by number (from [s] to [f])
    Add: function(s, f) {
        for (var i = s; i < f; i++) {
            Pagination.code += '<li><a href="' + Pagination.url + '" class="btn btn-default">' + i + '</a></li>';
        }
    },

    // add last page with separator
    Last: function() {
        Pagination.code += '<li><a href="' + Pagination.url + '" class="btn btn-default">>></a></li>';
    },

    // add first page with separator
    First: function() {
        Pagination.code += '<li><a href="' + Pagination.url + '" class="btn btn-default"><<</a></li>';
    },

    // add last page with separator
    Next: function() {
        Pagination.code += '<li><a href="' + Pagination.url + '" class="btn btn-default">></a></li>';
    },

    // add first page with separator
    Prev: function() {
        Pagination.code += '<li><a href="' + Pagination.url + '" class="btn btn-default"><</a></li>';
    },



    // --------------------
    // Handlers
    // --------------------

    // change page
    Click: function() {
			clearSelectedCheckbox();

			var selectPage = $("#pagination-"+Pagination.type.toLowerCase()+' .tblAjax__footer__toolbar__pagination').find('a.active').text();
			Pagination.clickPage = +this.innerHTML || '';
			if ( selectPage === NaN || selectPage > Pagination.size) { selectPage = 1; }

			switch (this.innerHTML) {
				case '&gt;&gt;': // last
					Pagination.clickPage = Pagination.size;
					break;

				case '&lt;&lt;': // first
					Pagination.clickPage = 1;
					break;

				case '&lt;': // prev
					Pagination.clickPage = parseInt(selectPage) - 1;
					if (Pagination.clickPage < 1) {
							Pagination.clickPage = 1;
					}

					break;

				case '&gt;': // next
					Pagination.clickPage = parseInt(selectPage) + 1;

					if (Pagination.clickPage > Pagination.size) {
							Pagination.clickPage = Pagination.size;
					}
					break;
			}

			if ( Pagination.type === 'KONTRAHENCI' ) {
				setItemLocalStorage('Bocian.biAuditForm.kontrahenci.pagination.page', Pagination.clickPage);
				Pagination.page = urlFetchKontrahenci(Pagination.clickPage);
			}
			else if ( Pagination.type === 'PRACOWNICY' ){
				setItemLocalStorage('Bocian.biAuditForm.pracownicy.pagination.page', Pagination.clickPage);
				Pagination.page = urlFetchPracownicy(Pagination.clickPage);
			}

        Pagination.Start();
    },


    // --------------------
    // Script structure pagination
    // --------------------

    // binding pages
    Bind: function() {
        var a = Pagination.e.getElementsByTagName('a');
				var currentPage = Pagination.clickPage || 1;
        for (var i = 0; i < a.length; i++) {
            if (+a[i].innerHTML === Pagination.page) a[i].className = 'btn btn-default active';
            a[i].addEventListener('click', Pagination.Click, false);
        }
    },

    // write pagination
    Finish: function() {
        Pagination.e.innerHTML = Pagination.code;
        Pagination.code = '</ul></nav>';
        Pagination.Bind();
    },


    // find pagination type
    Start: function() {
			Pagination.code = '';
			if ( Pagination.type === 'KONTRAHENCI' ) {
				Pagination.code = '<div class="foot-info tblAjax__footer__toolbar__info footer_pagination_menu_items"><p>Wiersze od <span id="paginationShowNextCount-KONTRAHENCI"></span> do ' + Pagination.total_items + ' z ' + Pagination.total_items + '</p></div>';
			} else if ( Pagination.type === 'PRACOWNICY' ) {
					Pagination.code = '<div class="foot-info tblAjax__footer__toolbar__info footer_pagination_menu_items"><p>Wiersze od <span id="paginationShowNextCount-PRACOWNICY"></span> do ' + Pagination.total_items + ' z ' + Pagination.total_items + '</p></div>';
			}
			Pagination.code += '<nav aria-label="Page navigation" class="footer_pagination_menu_items"><ul class="btn-group tblAjax__footer__toolbar__pagination smad-pagination">';
			Pagination.First();
			Pagination.Prev();


				if ( Pagination.type === 'KONTRAHENCI' ) {
					Pagination.page = getItemLocalStorage('Bocian.biAuditForm.kontrahenci.pagination.page') || 1;
				}
				else if ( Pagination.type === 'PRACOWNICY' ) {
					Pagination.page = getItemLocalStorage('Bocian.biAuditForm.pracownicy.pagination.page') || 1;
				}

				if ( Pagination.page > Pagination.size ) {
						Pagination.page = 1;
				}

        if (Pagination.size < Pagination.step * 2 + 6) {
            Pagination.Add(1, Pagination.size + 1);
        }
        else if (Pagination.page < Pagination.step * 2 + 1) {
            Pagination.Add(1, Pagination.step * 2 + 4);
        }
        else if (Pagination.page > Pagination.size - Pagination.step * 2) {
            Pagination.Add(Pagination.size - Pagination.step * 2 - 2, Pagination.size + 1);
        }
        else {
            Pagination.Add(Pagination.page - Pagination.step, Pagination.page + Pagination.step + 1);
        }
				Pagination.Next();
				Pagination.Last();
        Pagination.Finish();
    },


    // --------------------
    // Initialization
    // --------------------

    // binding buttons
    Buttons: function(e) {
        var nav = e.getElementsByTagName('a');
    },

    // create skeleton
    Create: function(e) {

        var html = [
             '<div></div>'  // pagination container
        ];

        e.innerHTML = html.join('');
        Pagination.e = e.getElementsByTagName('div')[0];
        Pagination.Buttons(e);
    },

    // init
    Init: function(e, data) {
        Pagination.Extend(data);
        Pagination.Create(e);
        Pagination.Start();
    }
};

function todo__fetchRaport(id) {
/*	p5WFS_GetFeature('default_db__x3A__BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA:BI_audit_ENERGA_RUM_KONTRAHENCI_POWIAZANIA', {
		primaryKey: id,
		resolve: 'all',
		resolveDepth: 3,
	}).then(function (features) {
		if(DBG) console.log('features', features)
	}).catch(function (e) {
		if(DBG) console.warn(e)
		p5UI__notifyAjaxCallback({ type: 'error', msg: e })
	})*/
}

function removeFiltersPracownicy(event, btnNode) {
	event.preventDefault()
	var fieldNameList = FIELD_LIST_PRACOWNICY
	fieldNameList.forEach(function (fieldName) {
		btnNode.form[fieldName].value = ''
	})
	urlFetchPracownicy(1)
}
function removeFiltersKontrahenci(event, btnNode) {
	event.preventDefault()
	var fieldNameList = FIELD_LIST_KONTRAHENCI
	fieldNameList.forEach(function (fieldName) {
		btnNode.form[fieldName].value = ''
	})
	urlFetchKontrahenci(1)
}

function onChangeFiltersPracownicy(event, inputNode) {
	urlFetchPracownicy(1)
}
function onKeypressFiltersPracownicy(event, inputNode) {
	if ("Enter" === event.key) {
		event.stopPropagation()
		event.preventDefault()
		urlFetchPracownicy(1)
		return false
	}
}
function onChangeFiltersKontrahenci(event, inputNode) {
	urlFetchKontrahenci(1)
}
function onKeypressFiltersKontrahenci(event, inputNode) {
	if ("Enter" === event.key) {
		event.stopPropagation()
		event.preventDefault()
		urlFetchKontrahenci(1)
		return false
	}
}

function loadMoreRecordFunctions(event, node, rowPK, namespace) {
	var _node = node
	var _rowPK = rowPK
	var toShow = true
	if (RECORD_MORE_FUNCTIONS_OPENED_NODE) {
		if (RECORD_MORE_FUNCTIONS_OPENED_NODE === node) toShow = false
		if (RECORD_MORE_FUNCTIONS_OPENED_NODE !== node) {
			jQuery(RECORD_MORE_FUNCTIONS_OPENED_NODE).popover('destroy')
		}
	}
	RECORD_MORE_FUNCTIONS_OPENED_NODE = node

	// jQuery(node).popover({
	// 	container: 'body',
	// 	placement: 'right',
	// 	trigger: 'click',
	// 	template: '<div class="popover" role="tooltip" style="max-width:600px;width:440px;">' +
	// 		'<div class="arrow"></div>' +
	// 		'<div style="display:block;position:relative;">' +
	// 			'<div class="popover-title">' +
	// 			'</div>' +
	// 			'<button type="button" class="close" onclick="return hideMoreRecordFunctionsPopover();" style="position:absolute;right:8px;top:6px;">&times;</button>' +
	// 		'</div>' +
	// 		'<div class="popover-content"></div>' +
	// 		'</div>' +
	// 	'',
	// 	html: true,
	// })
	// jQuery(node).popover('show')

	global.fetch(BASE_URLS + 'index.php?_route=ViewTableAjax&namespace=' + namespace + '&_task=moreFunctionsCellAjax&ID=' + rowPK, {
		credentials: 'same-origin'
	}).then(function (response) {
		return response.json()
	}).then(function (json) {
		var funcListWrap = $('<div></div>')
		var funcListNode = $('<ul class="list-unstyled popoverRowFunctions"></ul>').appendTo(funcListWrap)

		if (_node === RECORD_MORE_FUNCTIONS_OPENED_NODE) {
			if (json && 'success' === json.type && json.rowFunctions && json.rowFunctions.length > 0) {
				json.rowFunctions.forEach(function(funObj) {
					var funcNode = p5UI_TableAjax_generateFunctionNode(funObj, _rowPK, {ico: true, label: true});
					var funcItemNode = jQuery('<li></li>')
					funcItemNode.append(funcNode)
					funcListNode.append(funcItemNode)
				});
			}
		}

		// jQuery(RECORD_MORE_FUNCTIONS_OPENED_NODE).popover('destroy')
		jQuery(RECORD_MORE_FUNCTIONS_OPENED_NODE).popover({
			container: 'body',
			placement: 'right',
			trigger: 'click',
			template: '<div class="popover" role="tooltip" style="max-width:600px;width:440px;">' +
				'<div class="arrow"></div>' +
				'<div style="display:block;position:relative;">' +
					'<div class="popover-title">' +
					'</div>' +
					'<button type="button" class="close" onclick="return hideMoreRecordFunctionsPopover();" style="position:absolute;right:8px;top:6px;">&times;</button>' +
				'</div>' +
				'<div class="popover-content"></div>' +
				'</div>' +
			'',
			html: true,
			content: funcListWrap.html(),
		})
		jQuery(RECORD_MORE_FUNCTIONS_OPENED_NODE).popover('show')

	}).catch(function (err) {
		if(DBG)  console.log('err', err);
	})
}

var p5UI_TableAjax_generateFunctionNode = function(funObj, rowPK, props) {
	var defaultsProps = {
				ico: true,
				label: false
			},
			props = jQuery.extend({}, defaultsProps, props);
			funcNode = $('<a href="#" style="margin:0 2px;"></a>')
	;
	if ('href' in funObj) funcNode.attr('href', p5Utils__format(funObj.href, [rowPK]));
	if (props.ico) {
		if ('ico' in funObj) funcNode.append('<span class="' + funObj.ico + '"></span>');
	}
	if ('onclick' in funObj) funcNode.attr('onclick', p5Utils__format(funObj.onclick, [rowPK]));
	if ('title' in funObj) funcNode.attr('title', funObj.title);
	if ('target' in funObj) funcNode.attr('target', funObj.target);

	if (props.label) {
		if ('label' in funObj) {
			funcNode.append(' ' + funObj.label);
		} else if ('title' in funObj) {
			funcNode.append(' ' + funObj.title);
		}
	}

	return funcNode;
};
global.p5UI_TableAjax_generateFunctionNode = p5UI_TableAjax_generateFunctionNode


$(document).ready(function(){
	rootChangeForm();
	updateTopCounters();
});

global.hideMoreRecordFunctionsPopover = function() {
	if (RECORD_MORE_FUNCTIONS_OPENED_NODE) jQuery(RECORD_MORE_FUNCTIONS_OPENED_NODE).popover('destroy')
}
global.pracownicyLoadMoreRecordFunctions = function(event, node, rowPK) {
	return loadMoreRecordFunctions(event, node, rowPK, "default_db/BI_audit_ENERGA_PRACOWNICY/BI_audit_ENERGA_PRACOWNICY")
}
global.kontrahenciLoadMoreRecordFunctions = function(event, node, rowPK) {
	return loadMoreRecordFunctions(event, node, rowPK, "default_db/BI_audit_ENERGA_RUM_KONTRAHENCI/BI_audit_ENERGA_RUM_KONTRAHENCI")
}
global.removeFiltersPracownicy = removeFiltersPracownicy;
global.removeFiltersKontrahenci = removeFiltersKontrahenci;
global.onChangeFiltersPracownicy = onChangeFiltersPracownicy;
global.onKeypressFiltersPracownicy = onKeypressFiltersPracownicy;
global.onChangeFiltersKontrahenci = onChangeFiltersKontrahenci;
global.onKeypressFiltersKontrahenci = onKeypressFiltersKontrahenci;

global.checkAll = checkAll;
global.checkedChoiseItems = checkedChoiseItems;
global.catchEventCheckbox = catchEventCheckbox;
global.clearSelectedCheckbox = clearSelectedCheckbox;
global.getNameGroupById = getNameGroupById;
global.createGroupPracownicy = createGroupPracownicy;
global.createGroupKontrahenci = createGroupKontrahenci;
global.selectPage = selectPage;
global.detectChoiseFilter = detectChoiseFilter;

global.updateListIdBiAuditReaport = updateListIdBiAuditReaport;
global.deleteListIdBiAuditReaport = deleteListIdBiAuditReaport;

global.urlFetchPracownicy = urlFetchPracownicy;
global.generateBiAuditRaport = generateBiAuditRaport;
global.getAddressData = getAddressData;

global.loadCurrentReaportTitleInInput = loadCurrentReaportTitleInInput;
global.updateLocalStorageBiAuditReaportTitle = updateLocalStorageBiAuditReaportTitle;

global.Pagination = Pagination;
global.todo__fetchRaport = todo__fetchRaport;

global.initLocalStorage = initLocalStorage;
global.setItemLocalStorage = setItemLocalStorage;
global.getItemLocalStorage = getItemLocalStorage;
global.deleteItemLocalStorage = deleteItemLocalStorage;
global.defaultBIAuditLocalStorage = defaultBIAuditLocalStorage;
global.removeItemInArray = removeItemInArray;
global.removeItemArrayInArray = removeItemArrayInArray;

global.addPracownikToGroup = addPracownikToGroup;
global.addPracownikAllToGroup = addPracownikAllToGroup;
global.addKontrahenciToGroup = addKontrahenciToGroup;
global.addKontrahenciAllToGroup = addKontrahenciAllToGroup;
global.createPracownikAjax = createPracownikAjax;
global.createKontrahentAjax = createKontrahentAjax;
global.removePracownikFromGroup = removePracownikFromGroup;
global.removeKontrahenciFromGroup= removeKontrahenciFromGroup;

global.showViewUploadFile = showViewUploadFile;
global.parseCsvFile = parseCsvFile;
global.graphShowHide = graphShowHide;
global.clearListLocalStorageByType = clearListLocalStorageByType;

// message
global.messageCriticalSearchData = 'Krytyczne wielkości danych do przeszukania. Optymalna wartość głębokość szukania powiaząń to: 6';
global.defaultOnlyTarger = 'y';
